package Agent.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LabeledContainer;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.FlowLayoutEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class SemanticWebAgentEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2003;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public SemanticWebAgentEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy());
		super.createDefaultEditPolicies();
		installEditPolicy(
				EditPolicyRoles.SEMANTIC_ROLE,
				new Agent.diagram.edit.policies.SemanticWebAgentItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {

		FlowLayoutEditPolicy lep = new FlowLayoutEditPolicy() {

			protected Command createAddCommand(EditPart child, EditPart after) {
				return null;
			}

			protected Command createMoveChildCommand(EditPart child,
					EditPart after) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new SemanticWebAgentFigure();
	}

	/**
	 * @generated
	 */
	public SemanticWebAgentFigure getPrimaryShape() {
		return (SemanticWebAgentFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof Agent.diagram.edit.parts.SemanticWebAgentNameEditPart) {
			((Agent.diagram.edit.parts.SemanticWebAgentNameEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureSemanticWebAgentNameFigure());
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSemanticWebAgentAgentTypeCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSemanticWebAgentAgentStateCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof Agent.diagram.edit.parts.SemanticWebAgentNameEditPart) {
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSemanticWebAgentAgentTypeCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		if (childEditPart instanceof Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSemanticWebAgentAgentStateCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		if (editPart instanceof Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart) {
			return getPrimaryShape()
					.getFigureSemanticWebAgentAgentTypeCompartmentFigure();
		}
		if (editPart instanceof Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart) {
			return getPrimaryShape()
					.getFigureSemanticWebAgentAgentStateCompartmentFigure();
		}
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(4, 5);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(Agent.diagram.part.AgentVisualIDRegistry
				.getType(Agent.diagram.edit.parts.SemanticWebAgentNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(Agent.diagram.providers.AgentElementTypes.SemanticWebAgentPlays_4001);
		types.add(Agent.diagram.providers.AgentElementTypes.SemanticWebAgentIncludes_4005);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof Agent.diagram.edit.parts.RoleEditPart) {
			types.add(Agent.diagram.providers.AgentElementTypes.SemanticWebAgentPlays_4001);
		}
		if (targetEditPart instanceof Agent.diagram.edit.parts.CapabilitiesEditPart) {
			types.add(Agent.diagram.providers.AgentElementTypes.SemanticWebAgentIncludes_4005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == Agent.diagram.providers.AgentElementTypes.SemanticWebAgentPlays_4001) {
			types.add(Agent.diagram.providers.AgentElementTypes.Role_2001);
		} else if (relationshipType == Agent.diagram.providers.AgentElementTypes.SemanticWebAgentIncludes_4005) {
			types.add(Agent.diagram.providers.AgentElementTypes.Capabilities_2004);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public EditPart getTargetEditPart(Request request) {
		if (request instanceof CreateViewAndElementRequest) {
			CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request)
					.getViewAndElementDescriptor()
					.getCreateElementRequestAdapter();
			IElementType type = (IElementType) adapter
					.getAdapter(IElementType.class);
			if (type == Agent.diagram.providers.AgentElementTypes.AgentType_3009) {
				return getChildBySemanticHint(Agent.diagram.part.AgentVisualIDRegistry
						.getType(Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart.VISUAL_ID));
			}
			if (type == Agent.diagram.providers.AgentElementTypes.AgentState_3008) {
				return getChildBySemanticHint(Agent.diagram.part.AgentVisualIDRegistry
						.getType(Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart.VISUAL_ID));
			}
		}
		return super.getTargetEditPart(request);
	}

	/**
	 * @generated
	 */
	public class SemanticWebAgentFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureSemanticWebAgentNameFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureSemanticWebAgentAgentStateCompartmentFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureSemanticWebAgentAgentTypeCompartmentFigure;

		/**
		 * @generated
		 */
		public SemanticWebAgentFigure() {

			FlowLayout layoutThis = new FlowLayout();
			layoutThis.setStretchMinorAxis(false);
			layoutThis.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutThis.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutThis.setMajorSpacing(5);
			layoutThis.setMinorSpacing(5);
			layoutThis.setHorizontal(true);

			this.setLayoutManager(layoutThis);

			this.setFill(false);
			this.setOutline(false);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureSemanticWebAgentNameFigure = new WrappingLabel();
			fFigureSemanticWebAgentNameFigure.setText("<...>");
			fFigureSemanticWebAgentNameFigure
					.setForegroundColor(FFIGURESEMANTICWEBAGENTNAMEFIGURE_FORE);

			this.add(fFigureSemanticWebAgentNameFigure);

			fFigureSemanticWebAgentAgentStateCompartmentFigure = new LabeledContainer();

			fFigureSemanticWebAgentAgentStateCompartmentFigure
					.setBackgroundColor(FFIGURESEMANTICWEBAGENTAGENTSTATECOMPARTMENTFIGURE_BACK);
			fFigureSemanticWebAgentAgentStateCompartmentFigure
					.setBorder(new MarginBorder(getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4), getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4)));

			this.add(fFigureSemanticWebAgentAgentStateCompartmentFigure);

			FlowLayout layoutFFigureSemanticWebAgentAgentStateCompartmentFigure = new FlowLayout();
			layoutFFigureSemanticWebAgentAgentStateCompartmentFigure
					.setStretchMinorAxis(false);
			layoutFFigureSemanticWebAgentAgentStateCompartmentFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureSemanticWebAgentAgentStateCompartmentFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureSemanticWebAgentAgentStateCompartmentFigure
					.setMajorSpacing(5);
			layoutFFigureSemanticWebAgentAgentStateCompartmentFigure
					.setMinorSpacing(5);
			layoutFFigureSemanticWebAgentAgentStateCompartmentFigure
					.setHorizontal(true);

			fFigureSemanticWebAgentAgentStateCompartmentFigure
					.setLayoutManager(layoutFFigureSemanticWebAgentAgentStateCompartmentFigure);

			WrappingLabel semanticWebAgentAgentStateCompartmentName1 = new WrappingLabel();
			semanticWebAgentAgentStateCompartmentName1.setText("<AgentStates>");
			semanticWebAgentAgentStateCompartmentName1
					.setForegroundColor(SEMANTICWEBAGENTAGENTSTATECOMPARTMENTNAME1_FORE);

			fFigureSemanticWebAgentAgentStateCompartmentFigure
					.add(semanticWebAgentAgentStateCompartmentName1);

			fFigureSemanticWebAgentAgentTypeCompartmentFigure = new LabeledContainer();

			fFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setBackgroundColor(FFIGURESEMANTICWEBAGENTAGENTTYPECOMPARTMENTFIGURE_BACK);
			fFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setBorder(new MarginBorder(getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4), getMapMode().DPtoLP(5),
							getMapMode().DPtoLP(4)));

			this.add(fFigureSemanticWebAgentAgentTypeCompartmentFigure);

			FlowLayout layoutFFigureSemanticWebAgentAgentTypeCompartmentFigure = new FlowLayout();
			layoutFFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setStretchMinorAxis(false);
			layoutFFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setMajorSpacing(5);
			layoutFFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setMinorSpacing(5);
			layoutFFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setHorizontal(true);

			fFigureSemanticWebAgentAgentTypeCompartmentFigure
					.setLayoutManager(layoutFFigureSemanticWebAgentAgentTypeCompartmentFigure);

			WrappingLabel semanticWebAgentAgentTypeCompartmentName1 = new WrappingLabel();
			semanticWebAgentAgentTypeCompartmentName1.setText("<AgentTypes>");
			semanticWebAgentAgentTypeCompartmentName1
					.setForegroundColor(SEMANTICWEBAGENTAGENTTYPECOMPARTMENTNAME1_FORE);

			fFigureSemanticWebAgentAgentTypeCompartmentFigure
					.add(semanticWebAgentAgentTypeCompartmentName1);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureSemanticWebAgentNameFigure() {
			return fFigureSemanticWebAgentNameFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureSemanticWebAgentAgentStateCompartmentFigure() {
			return fFigureSemanticWebAgentAgentStateCompartmentFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureSemanticWebAgentAgentTypeCompartmentFigure() {
			return fFigureSemanticWebAgentAgentTypeCompartmentFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color FFIGURESEMANTICWEBAGENTNAMEFIGURE_FORE = new Color(null,
			0, 0, 0);

	/**
	 * @generated
	 */
	static final Color FFIGURESEMANTICWEBAGENTAGENTSTATECOMPARTMENTFIGURE_BACK = new Color(
			null, 180, 180, 180);

	/**
	 * @generated
	 */
	static final Color SEMANTICWEBAGENTAGENTSTATECOMPARTMENTNAME1_FORE = new Color(
			null, 0, 0, 0);

	/**
	 * @generated
	 */
	static final Color FFIGURESEMANTICWEBAGENTAGENTTYPECOMPARTMENTFIGURE_BACK = new Color(
			null, 180, 180, 180);

	/**
	 * @generated
	 */
	static final Color SEMANTICWEBAGENTAGENTTYPECOMPARTMENTNAME1_FORE = new Color(
			null, 0, 0, 0);

}
