package Agent.diagram.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

/**
 * @generated
 */
public class AgentNavigatorContentProvider implements ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	@SuppressWarnings({ "unchecked", "serial", "rawtypes" })
	public AgentNavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		myViewer = null;
		unloadAllResources();
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	void unloadAllResources() {
		for (Resource nextResource : myEditingDomain.getResourceSet()
				.getResources()) {
			nextResource.unload();
		}
	}

	/**
	 * @generated
	 */
	void asyncRefresh() {
		if (myViewer != null && !myViewer.getControl().isDisposed()) {
			myViewer.getControl().getDisplay()
					.asyncExec(myViewerRefreshRunnable);
		}
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			ArrayList<Agent.diagram.navigator.AgentNavigatorItem> result = new ArrayList<Agent.diagram.navigator.AgentNavigatorItem>();
			ArrayList<View> topViews = new ArrayList<View>(resource
					.getContents().size());
			for (EObject o : resource.getContents()) {
				if (o instanceof View) {
					topViews.add((View) o);
				}
			}
			result.addAll(createNavigatorItems(
					selectViewsByType(
							topViews,
							Agent.diagram.edit.parts.AgentViewpointEditPart.MODEL_ID),
					file, false));
			return result.toArray();
		}

		if (parentElement instanceof Agent.diagram.navigator.AgentNavigatorGroup) {
			Agent.diagram.navigator.AgentNavigatorGroup group = (Agent.diagram.navigator.AgentNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof Agent.diagram.navigator.AgentNavigatorItem) {
			Agent.diagram.navigator.AgentNavigatorItem navigatorItem = (Agent.diagram.navigator.AgentNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (Agent.diagram.part.AgentVisualIDRegistry.getVisualID(view)) {

		case Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Agent.diagram.navigator.AgentNavigatorGroup target = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_SemanticWebAgentPlays_4001_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Agent.diagram.navigator.AgentNavigatorGroup source = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_SemanticWebAgentPlays_4001_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Node sv = (Node) view;
			Agent.diagram.navigator.AgentNavigatorGroup outgoinglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_SemanticWebAgent_2003_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentSWAAgentStateCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.AgentStateEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentSWAAgentTypeCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.AgentTypeEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.BehaviourExecutesEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Agent.diagram.navigator.AgentNavigatorGroup target = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_BehaviourExecutes_4007_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Agent.diagram.navigator.AgentNavigatorGroup source = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_BehaviourExecutes_4007_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Node sv = (Node) view;
			Agent.diagram.navigator.AgentNavigatorGroup incominglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_Goal_3003_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Agent.diagram.navigator.AgentNavigatorGroup target = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_SemanticWebAgentIncludes_4005_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Agent.diagram.navigator.AgentNavigatorGroup source = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_SemanticWebAgentIncludes_4005_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Node sv = (Node) view;
			Agent.diagram.navigator.AgentNavigatorGroup outgoinglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_Behaviour_2002_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Agent.diagram.navigator.AgentNavigatorGroup incominglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_Behaviour_2002_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.BehaviourExecutesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.RoleHasEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Node sv = (Node) view;
			Agent.diagram.navigator.AgentNavigatorGroup incominglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_Role_2001_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Agent.diagram.navigator.AgentNavigatorGroup outgoinglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_Role_2001_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.RoleHasEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Agent.diagram.navigator.AgentNavigatorGroup target = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_PlanDispatches_4002_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Agent.diagram.navigator.AgentNavigatorGroup source = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_PlanDispatches_4002_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Node sv = (Node) view;
			Agent.diagram.navigator.AgentNavigatorGroup outgoinglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_Plan_3004_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Agent.diagram.navigator.AgentNavigatorGroup incominglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_Plan_3004_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.BehaviourExecutesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Node sv = (Node) view;
			Agent.diagram.navigator.AgentNavigatorGroup incominglinks = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_Capabilities_2004_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.CapabilitiesCapBeliefCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.BeliefEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.CapabilitiesCapGoalCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.CapabilitiesCapPlanCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.RoleHasEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			Agent.diagram.navigator.AgentNavigatorGroup target = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_RoleHas_4006_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Agent.diagram.navigator.AgentNavigatorGroup source = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_RoleHas_4006_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID: {
			LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem> result = new LinkedList<Agent.diagram.navigator.AgentAbstractNavigatorItem>();
			Diagram sv = (Diagram) view;
			Agent.diagram.navigator.AgentNavigatorGroup links = new Agent.diagram.navigator.AgentNavigatorGroup(
					Agent.diagram.part.Messages.NavigatorGroupName_AgentViewpoint_1000_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.BehaviourExecutesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					Agent.diagram.part.AgentVisualIDRegistry
							.getType(Agent.diagram.edit.parts.RoleHasEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksSourceByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksTargetByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getOutgoingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getIncomingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getChildrenByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getDiagramLinksByType(
			Collection<Diagram> diagrams, String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (Diagram nextDiagram : diagrams) {
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	// TODO refactor as static method
	/**
	 * @generated
	 */
	private Collection<View> selectViewsByType(Collection<View> views,
			String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (View nextView : views) {
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return Agent.diagram.edit.parts.AgentViewpointEditPart.MODEL_ID
				.equals(Agent.diagram.part.AgentVisualIDRegistry
						.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection<Agent.diagram.navigator.AgentNavigatorItem> createNavigatorItems(
			Collection<View> views, Object parent, boolean isLeafs) {
		ArrayList<Agent.diagram.navigator.AgentNavigatorItem> result = new ArrayList<Agent.diagram.navigator.AgentNavigatorItem>(
				views.size());
		for (View nextView : views) {
			result.add(new Agent.diagram.navigator.AgentNavigatorItem(nextView,
					parent, isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof Agent.diagram.navigator.AgentAbstractNavigatorItem) {
			Agent.diagram.navigator.AgentAbstractNavigatorItem abstractNavigatorItem = (Agent.diagram.navigator.AgentAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
