package Agent.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * @generated
 */
public class AgentElementTypes {

	/**
	 * @generated
	 */
	private AgentElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType AgentViewpoint_1000 = getElementType("AgentViewpoint.diagram.AgentViewpoint_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Role_2001 = getElementType("AgentViewpoint.diagram.Role_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Behaviour_2002 = getElementType("AgentViewpoint.diagram.Behaviour_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SemanticWebAgent_2003 = getElementType("AgentViewpoint.diagram.SemanticWebAgent_2003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Capabilities_2004 = getElementType("AgentViewpoint.diagram.Capabilities_2004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType AgentState_3008 = getElementType("AgentViewpoint.diagram.AgentState_3008"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType AgentType_3009 = getElementType("AgentViewpoint.diagram.AgentType_3009"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Belief_3002 = getElementType("AgentViewpoint.diagram.Belief_3002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Goal_3003 = getElementType("AgentViewpoint.diagram.Goal_3003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Plan_3004 = getElementType("AgentViewpoint.diagram.Plan_3004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SemanticWebAgentPlays_4001 = getElementType("AgentViewpoint.diagram.SemanticWebAgentPlays_4001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType PlanDispatches_4002 = getElementType("AgentViewpoint.diagram.PlanDispatches_4002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType BehaviourExecutes_4007 = getElementType("AgentViewpoint.diagram.BehaviourExecutes_4007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SemanticWebAgentIncludes_4005 = getElementType("AgentViewpoint.diagram.SemanticWebAgentIncludes_4005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RoleHas_4006 = getElementType("AgentViewpoint.diagram.RoleHas_4006"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return Agent.diagram.part.AgentDiagramEditorPlugin
						.getInstance().getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(AgentViewpoint_1000,
					Agent.AgentPackage.eINSTANCE.getAgentViewpoint());

			elements.put(Role_2001, Agent.AgentPackage.eINSTANCE.getRole());

			elements.put(Behaviour_2002,
					Agent.AgentPackage.eINSTANCE.getBehaviour());

			elements.put(SemanticWebAgent_2003,
					Agent.AgentPackage.eINSTANCE.getSemanticWebAgent());

			elements.put(Capabilities_2004,
					Agent.AgentPackage.eINSTANCE.getCapabilities());

			elements.put(AgentState_3008,
					Agent.AgentPackage.eINSTANCE.getAgentState());

			elements.put(AgentType_3009,
					Agent.AgentPackage.eINSTANCE.getAgentType());

			elements.put(Belief_3002, Agent.AgentPackage.eINSTANCE.getBelief());

			elements.put(Goal_3003, Agent.AgentPackage.eINSTANCE.getGoal());

			elements.put(Plan_3004, Agent.AgentPackage.eINSTANCE.getPlan());

			elements.put(SemanticWebAgentPlays_4001,
					Agent.AgentPackage.eINSTANCE.getSemanticWebAgent_Plays());

			elements.put(PlanDispatches_4002,
					Agent.AgentPackage.eINSTANCE.getPlan_Dispatches());

			elements.put(BehaviourExecutes_4007,
					Agent.AgentPackage.eINSTANCE.getBehaviour_Executes());

			elements.put(SemanticWebAgentIncludes_4005,
					Agent.AgentPackage.eINSTANCE.getSemanticWebAgent_Includes());

			elements.put(RoleHas_4006,
					Agent.AgentPackage.eINSTANCE.getRole_Has());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(AgentViewpoint_1000);
			KNOWN_ELEMENT_TYPES.add(Role_2001);
			KNOWN_ELEMENT_TYPES.add(Behaviour_2002);
			KNOWN_ELEMENT_TYPES.add(SemanticWebAgent_2003);
			KNOWN_ELEMENT_TYPES.add(Capabilities_2004);
			KNOWN_ELEMENT_TYPES.add(AgentState_3008);
			KNOWN_ELEMENT_TYPES.add(AgentType_3009);
			KNOWN_ELEMENT_TYPES.add(Belief_3002);
			KNOWN_ELEMENT_TYPES.add(Goal_3003);
			KNOWN_ELEMENT_TYPES.add(Plan_3004);
			KNOWN_ELEMENT_TYPES.add(SemanticWebAgentPlays_4001);
			KNOWN_ELEMENT_TYPES.add(PlanDispatches_4002);
			KNOWN_ELEMENT_TYPES.add(BehaviourExecutes_4007);
			KNOWN_ELEMENT_TYPES.add(SemanticWebAgentIncludes_4005);
			KNOWN_ELEMENT_TYPES.add(RoleHas_4006);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case Agent.diagram.edit.parts.AgentViewpointEditPart.VISUAL_ID:
			return AgentViewpoint_1000;
		case Agent.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			return Role_2001;
		case Agent.diagram.edit.parts.BehaviourEditPart.VISUAL_ID:
			return Behaviour_2002;
		case Agent.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
			return SemanticWebAgent_2003;
		case Agent.diagram.edit.parts.CapabilitiesEditPart.VISUAL_ID:
			return Capabilities_2004;
		case Agent.diagram.edit.parts.AgentStateEditPart.VISUAL_ID:
			return AgentState_3008;
		case Agent.diagram.edit.parts.AgentTypeEditPart.VISUAL_ID:
			return AgentType_3009;
		case Agent.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
			return Belief_3002;
		case Agent.diagram.edit.parts.GoalEditPart.VISUAL_ID:
			return Goal_3003;
		case Agent.diagram.edit.parts.PlanEditPart.VISUAL_ID:
			return Plan_3004;
		case Agent.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID:
			return SemanticWebAgentPlays_4001;
		case Agent.diagram.edit.parts.PlanDispatchesEditPart.VISUAL_ID:
			return PlanDispatches_4002;
		case Agent.diagram.edit.parts.BehaviourExecutesEditPart.VISUAL_ID:
			return BehaviourExecutes_4007;
		case Agent.diagram.edit.parts.SemanticWebAgentIncludesEditPart.VISUAL_ID:
			return SemanticWebAgentIncludes_4005;
		case Agent.diagram.edit.parts.RoleHasEditPart.VISUAL_ID:
			return RoleHas_4006;
		}
		return null;
	}

}
