/*
 * 
 */
package environment.diagram.part;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import environment.diagram.providers.EnvironmentElementTypes;

/**
 * @generated
 */
public class EnvironmentPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createObjects1Group());
		paletteRoot.add(createConnections2Group());
	}

	/**
	 * Creates "Objects" palette tool group
	 * @generated
	 */
	private PaletteContainer createObjects1Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Objects1Group_title);
		paletteContainer.setId("createObjects1Group"); //$NON-NLS-1$
		paletteContainer.add(createEnvironment1CreationTool());
		paletteContainer.add(createFact2CreationTool());
		paletteContainer.add(createResource3CreationTool());
		paletteContainer.add(createSemanticWebAgent4CreationTool());
		paletteContainer.add(createService5CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Connections" palette tool group
	 * @generated
	 */
	private PaletteContainer createConnections2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Connections2Group_title);
		paletteContainer.setId("createConnections2Group"); //$NON-NLS-1$
		paletteContainer.add(createAccess1CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createEnvironment1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Environment1CreationTool_title,
				Messages.Environment1CreationTool_desc,
				Collections
						.singletonList(EnvironmentElementTypes.Environment_2002));
		entry.setId("createEnvironment1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(EnvironmentElementTypes
				.getImageDescriptor(EnvironmentElementTypes.Environment_2002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createFact2CreationTool() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(EnvironmentElementTypes.Fact_3003);
		types.add(EnvironmentElementTypes.Fact_2003);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Fact2CreationTool_title,
				Messages.Fact2CreationTool_desc, types);
		entry.setId("createFact2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(EnvironmentElementTypes
				.getImageDescriptor(EnvironmentElementTypes.Fact_3003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createResource3CreationTool() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(EnvironmentElementTypes.Resource_3001);
		types.add(EnvironmentElementTypes.Resource_2005);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Resource3CreationTool_title,
				Messages.Resource3CreationTool_desc, types);
		entry.setId("createResource3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(EnvironmentElementTypes
				.getImageDescriptor(EnvironmentElementTypes.Resource_3001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSemanticWebAgent4CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.SemanticWebAgent4CreationTool_title,
				Messages.SemanticWebAgent4CreationTool_desc,
				Collections
						.singletonList(EnvironmentElementTypes.SemanticWebAgent_2004));
		entry.setId("createSemanticWebAgent4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(EnvironmentElementTypes
				.getImageDescriptor(EnvironmentElementTypes.SemanticWebAgent_2004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createService5CreationTool() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(EnvironmentElementTypes.Service_2001);
		types.add(EnvironmentElementTypes.Service_3002);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Service5CreationTool_title,
				Messages.Service5CreationTool_desc, types);
		entry.setId("createService5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(EnvironmentElementTypes
				.getImageDescriptor(EnvironmentElementTypes.Service_2001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAccess1CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Access1CreationTool_title,
				Messages.Access1CreationTool_desc,
				Collections
						.singletonList(EnvironmentElementTypes.SemanticWebAgentAccess_4001));
		entry.setId("createAccess1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(EnvironmentElementTypes
				.getImageDescriptor(EnvironmentElementTypes.SemanticWebAgentAccess_4001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List<IElementType> elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List<IElementType> relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
