/*
 * 
 */
package environment.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

import environment.EnvironmentPackage;
import environment.EnvironmentViewpoint;
import environment.diagram.edit.parts.EnvironmentEditPart;
import environment.diagram.edit.parts.EnvironmentEnvironmentHasFactCompartmentEditPart;
import environment.diagram.edit.parts.EnvironmentEnvironmentHasResourceCompartmentEditPart;
import environment.diagram.edit.parts.EnvironmentEnvironmentHasServiceCompartmentEditPart;
import environment.diagram.edit.parts.EnvironmentNameEditPart;
import environment.diagram.edit.parts.EnvironmentViewpointEditPart;
import environment.diagram.edit.parts.Fact2EditPart;
import environment.diagram.edit.parts.FactEditPart;
import environment.diagram.edit.parts.FactName2EditPart;
import environment.diagram.edit.parts.FactNameEditPart;
import environment.diagram.edit.parts.Resource2EditPart;
import environment.diagram.edit.parts.ResourceEditPart;
import environment.diagram.edit.parts.ResourceName2EditPart;
import environment.diagram.edit.parts.ResourceNameEditPart;
import environment.diagram.edit.parts.SemanticWebAgentAccessEditPart;
import environment.diagram.edit.parts.SemanticWebAgentAccessExternalLabelEditPart;
import environment.diagram.edit.parts.SemanticWebAgentEditPart;
import environment.diagram.edit.parts.SemanticWebAgentNameEditPart;
import environment.diagram.edit.parts.Service2EditPart;
import environment.diagram.edit.parts.ServiceEditPart;
import environment.diagram.edit.parts.ServiceName2EditPart;
import environment.diagram.edit.parts.ServiceNameEditPart;
import environment.diagram.edit.parts.WrappingLabelEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class EnvironmentVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "Environment.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (EnvironmentViewpointEditPart.MODEL_ID.equals(view.getType())) {
				return EnvironmentViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return environment.diagram.part.EnvironmentVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				EnvironmentDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (EnvironmentPackage.eINSTANCE.getEnvironmentViewpoint()
				.isSuperTypeOf(domainElement.eClass())
				&& isDiagram((EnvironmentViewpoint) domainElement)) {
			return EnvironmentViewpointEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = environment.diagram.part.EnvironmentVisualIDRegistry
				.getModelID(containerView);
		if (!EnvironmentViewpointEditPart.MODEL_ID.equals(containerModelID)
				&& !"environment".equals(containerModelID)) { //$NON-NLS-1$
			return -1;
		}
		int containerVisualID;
		if (EnvironmentViewpointEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = environment.diagram.part.EnvironmentVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = EnvironmentViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case EnvironmentViewpointEditPart.VISUAL_ID:
			if (EnvironmentPackage.eINSTANCE.getService().isSuperTypeOf(
					domainElement.eClass())) {
				return ServiceEditPart.VISUAL_ID;
			}
			if (EnvironmentPackage.eINSTANCE.getEnvironment().isSuperTypeOf(
					domainElement.eClass())) {
				return EnvironmentEditPart.VISUAL_ID;
			}
			if (EnvironmentPackage.eINSTANCE.getFact().isSuperTypeOf(
					domainElement.eClass())) {
				return FactEditPart.VISUAL_ID;
			}
			if (EnvironmentPackage.eINSTANCE.getSemanticWebAgent()
					.isSuperTypeOf(domainElement.eClass())) {
				return SemanticWebAgentEditPart.VISUAL_ID;
			}
			if (EnvironmentPackage.eINSTANCE.getResource().isSuperTypeOf(
					domainElement.eClass())) {
				return ResourceEditPart.VISUAL_ID;
			}
			break;
		case EnvironmentEnvironmentHasResourceCompartmentEditPart.VISUAL_ID:
			if (EnvironmentPackage.eINSTANCE.getResource().isSuperTypeOf(
					domainElement.eClass())) {
				return Resource2EditPart.VISUAL_ID;
			}
			break;
		case EnvironmentEnvironmentHasServiceCompartmentEditPart.VISUAL_ID:
			if (EnvironmentPackage.eINSTANCE.getService().isSuperTypeOf(
					domainElement.eClass())) {
				return Service2EditPart.VISUAL_ID;
			}
			break;
		case EnvironmentEnvironmentHasFactCompartmentEditPart.VISUAL_ID:
			if (EnvironmentPackage.eINSTANCE.getFact().isSuperTypeOf(
					domainElement.eClass())) {
				return Fact2EditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = environment.diagram.part.EnvironmentVisualIDRegistry
				.getModelID(containerView);
		if (!EnvironmentViewpointEditPart.MODEL_ID.equals(containerModelID)
				&& !"environment".equals(containerModelID)) { //$NON-NLS-1$
			return false;
		}
		int containerVisualID;
		if (EnvironmentViewpointEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = environment.diagram.part.EnvironmentVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = EnvironmentViewpointEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case EnvironmentViewpointEditPart.VISUAL_ID:
			if (ServiceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (EnvironmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FactEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SemanticWebAgentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ResourceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ServiceEditPart.VISUAL_ID:
			if (ServiceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case EnvironmentEditPart.VISUAL_ID:
			if (EnvironmentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (EnvironmentEnvironmentHasResourceCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (EnvironmentEnvironmentHasServiceCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (EnvironmentEnvironmentHasFactCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case FactEditPart.VISUAL_ID:
			if (FactNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SemanticWebAgentEditPart.VISUAL_ID:
			if (SemanticWebAgentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ResourceEditPart.VISUAL_ID:
			if (ResourceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Resource2EditPart.VISUAL_ID:
			if (ResourceName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Service2EditPart.VISUAL_ID:
			if (ServiceName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Fact2EditPart.VISUAL_ID:
			if (FactName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case EnvironmentEnvironmentHasResourceCompartmentEditPart.VISUAL_ID:
			if (Resource2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case EnvironmentEnvironmentHasServiceCompartmentEditPart.VISUAL_ID:
			if (Service2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case EnvironmentEnvironmentHasFactCompartmentEditPart.VISUAL_ID:
			if (Fact2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SemanticWebAgentAccessEditPart.VISUAL_ID:
			if (SemanticWebAgentAccessExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(EnvironmentViewpoint element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		switch (visualID) {
		case EnvironmentEnvironmentHasResourceCompartmentEditPart.VISUAL_ID:
		case EnvironmentEnvironmentHasServiceCompartmentEditPart.VISUAL_ID:
		case EnvironmentEnvironmentHasFactCompartmentEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case EnvironmentViewpointEditPart.VISUAL_ID:
			return false;
		case ServiceEditPart.VISUAL_ID:
		case FactEditPart.VISUAL_ID:
		case SemanticWebAgentEditPart.VISUAL_ID:
		case ResourceEditPart.VISUAL_ID:
		case Resource2EditPart.VISUAL_ID:
		case Service2EditPart.VISUAL_ID:
		case Fact2EditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return environment.diagram.part.EnvironmentVisualIDRegistry
					.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return environment.diagram.part.EnvironmentVisualIDRegistry
					.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return environment.diagram.part.EnvironmentVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return environment.diagram.part.EnvironmentVisualIDRegistry
					.checkNodeVisualID(containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return environment.diagram.part.EnvironmentVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return environment.diagram.part.EnvironmentVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
