/*
 * 
 */
package MASandOrg.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class MASandOrgVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "MASandOrg.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.MODEL_ID
					.equals(view.getType())) {
				return MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return MASandOrg.diagram.part.MASandOrgVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				MASandOrg.diagram.part.MASandOrgDiagramEditorPlugin
						.getInstance().logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (MASandOrg.MASandOrgPackage.eINSTANCE.getMASandOrgViewpoint()
				.isSuperTypeOf(domainElement.eClass())
				&& isDiagram((MASandOrg.MASandOrgViewpoint) domainElement)) {
			return MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = MASandOrg.diagram.part.MASandOrgVisualIDRegistry
				.getModelID(containerView);
		if (!MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.MODEL_ID
				.equals(containerModelID)
				&& !"MASandOrg".equals(containerModelID)) { //$NON-NLS-1$
			return -1;
		}
		int containerVisualID;
		if (MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.VISUAL_ID:
			if (MASandOrg.MASandOrgPackage.eINSTANCE
					.getSemanticWebOrganization().isSuperTypeOf(
							domainElement.eClass())) {
				return MASandOrg.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID;
			}
			if (MASandOrg.MASandOrgPackage.eINSTANCE.getRole().isSuperTypeOf(
					domainElement.eClass())) {
				return MASandOrg.diagram.edit.parts.RoleEditPart.VISUAL_ID;
			}
			if (MASandOrg.MASandOrgPackage.eINSTANCE.getSemanticWebAgent()
					.isSuperTypeOf(domainElement.eClass())) {
				return MASandOrg.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID;
			}
			if (MASandOrg.MASandOrgPackage.eINSTANCE.getEnvironment()
					.isSuperTypeOf(domainElement.eClass())) {
				return MASandOrg.diagram.edit.parts.EnvironmentEditPart.VISUAL_ID;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartmentEditPart.VISUAL_ID:
			if (MASandOrg.MASandOrgPackage.eINSTANCE
					.getSemanticWebOrganization().isSuperTypeOf(
							domainElement.eClass())) {
				return MASandOrg.diagram.edit.parts.SemanticWebOrganization2EditPart.VISUAL_ID;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartment2EditPart.VISUAL_ID:
			if (MASandOrg.MASandOrgPackage.eINSTANCE
					.getSemanticWebOrganization().isSuperTypeOf(
							domainElement.eClass())) {
				return MASandOrg.diagram.edit.parts.SemanticWebOrganization2EditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = MASandOrg.diagram.part.MASandOrgVisualIDRegistry
				.getModelID(containerView);
		if (!MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.MODEL_ID
				.equals(containerModelID)
				&& !"MASandOrg".equals(containerModelID)) { //$NON-NLS-1$
			return false;
		}
		int containerVisualID;
		if (MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MASandOrg.diagram.edit.parts.RoleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MASandOrg.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MASandOrg.diagram.edit.parts.EnvironmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganizationNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.RoleNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebAgentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.EnvironmentEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.EnvironmentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebOrganization2EditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganizationName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartmentEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganization2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartment2EditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganization2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationHasEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganizationHasExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationInteracts_withEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebOrganizationInteracts_withExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebAgentWorks_inEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebAgentWorks_inExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MASandOrg.diagram.edit.parts.SemanticWebAgentCooperatesEditPart.VISUAL_ID:
			if (MASandOrg.diagram.edit.parts.SemanticWebAgentCooperatesExternalLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(MASandOrg.MASandOrgViewpoint element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		switch (visualID) {
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartmentEditPart.VISUAL_ID:
		case MASandOrg.diagram.edit.parts.SemanticWebOrganizationSemanticWebOrganizationContainsCompartment2EditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case MASandOrg.diagram.edit.parts.MASandOrgViewpointEditPart.VISUAL_ID:
			return false;
		case MASandOrg.diagram.edit.parts.RoleEditPart.VISUAL_ID:
		case MASandOrg.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID:
		case MASandOrg.diagram.edit.parts.EnvironmentEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.checkNodeVisualID(containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return MASandOrg.diagram.part.MASandOrgVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
