/*
 * 
 */
package Ontology.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * @generated
 */
public class OntologyElementTypes {

	/**
	 * @generated
	 */
	private OntologyElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType OntologyViewpoint_1000 = getElementType("Ontology.diagram.OntologyViewpoint_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RoleOntology_2001 = getElementType("Ontology.diagram.RoleOntology_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType OrganizationOntology_2002 = getElementType("Ontology.diagram.OrganizationOntology_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ServiceOntology_2003 = getElementType("Ontology.diagram.ServiceOntology_2003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Belief_2004 = getElementType("Ontology.diagram.Belief_2004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Fact_2005 = getElementType("Ontology.diagram.Fact_2005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SemanticWebOrganization_2006 = getElementType("Ontology.diagram.SemanticWebOrganization_2006"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Role_2007 = getElementType("Ontology.diagram.Role_2007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SWS_2009 = getElementType("Ontology.diagram.SWS_2009"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType OntologyMediatorRole_2008 = getElementType("Ontology.diagram.OntologyMediatorRole_2008"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType OWLOntologyIncludes_4001 = getElementType("Ontology.diagram.OWLOntologyIncludes_4001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SemanticWebOrganizationKnowsOrg_4007 = getElementType("Ontology.diagram.SemanticWebOrganizationKnowsOrg_4007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SWSDepends_on_4003 = getElementType("Ontology.diagram.SWSDepends_on_4003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RoleKnowsRoleOnt_4004 = getElementType("Ontology.diagram.RoleKnowsRoleOnt_4004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RoleKnowsOrgOnt_4005 = getElementType("Ontology.diagram.RoleKnowsOrgOnt_4005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType OntologyMediatorRoleKnowsService_4008 = getElementType("Ontology.diagram.OntologyMediatorRoleKnowsService_4008"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return Ontology.diagram.part.OntologyDiagramEditorPlugin
						.getInstance().getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(OntologyViewpoint_1000,
					Ontology.OntologyPackage.eINSTANCE.getOntologyViewpoint());

			elements.put(RoleOntology_2001,
					Ontology.OntologyPackage.eINSTANCE.getRoleOntology());

			elements.put(OrganizationOntology_2002,
					Ontology.OntologyPackage.eINSTANCE
							.getOrganizationOntology());

			elements.put(ServiceOntology_2003,
					Ontology.OntologyPackage.eINSTANCE.getServiceOntology());

			elements.put(Belief_2004,
					Ontology.OntologyPackage.eINSTANCE.getBelief());

			elements.put(Fact_2005,
					Ontology.OntologyPackage.eINSTANCE.getFact());

			elements.put(SemanticWebOrganization_2006,
					Ontology.OntologyPackage.eINSTANCE
							.getSemanticWebOrganization());

			elements.put(Role_2007,
					Ontology.OntologyPackage.eINSTANCE.getRole());

			elements.put(SWS_2009, Ontology.OntologyPackage.eINSTANCE.getSWS());

			elements.put(OntologyMediatorRole_2008,
					Ontology.OntologyPackage.eINSTANCE
							.getOntologyMediatorRole());

			elements.put(OWLOntologyIncludes_4001,
					Ontology.OntologyPackage.eINSTANCE
							.getOWLOntology_Includes());

			elements.put(SemanticWebOrganizationKnowsOrg_4007,
					Ontology.OntologyPackage.eINSTANCE
							.getSemanticWebOrganization_KnowsOrg());

			elements.put(SWSDepends_on_4003,
					Ontology.OntologyPackage.eINSTANCE.getSWS_Depends_on());

			elements.put(RoleKnowsRoleOnt_4004,
					Ontology.OntologyPackage.eINSTANCE.getRole_KnowsRoleOnt());

			elements.put(RoleKnowsOrgOnt_4005,
					Ontology.OntologyPackage.eINSTANCE.getRole_KnowsOrgOnt());

			elements.put(OntologyMediatorRoleKnowsService_4008,
					Ontology.OntologyPackage.eINSTANCE
							.getOntologyMediatorRole_KnowsService());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(OntologyViewpoint_1000);
			KNOWN_ELEMENT_TYPES.add(RoleOntology_2001);
			KNOWN_ELEMENT_TYPES.add(OrganizationOntology_2002);
			KNOWN_ELEMENT_TYPES.add(ServiceOntology_2003);
			KNOWN_ELEMENT_TYPES.add(Belief_2004);
			KNOWN_ELEMENT_TYPES.add(Fact_2005);
			KNOWN_ELEMENT_TYPES.add(SemanticWebOrganization_2006);
			KNOWN_ELEMENT_TYPES.add(Role_2007);
			KNOWN_ELEMENT_TYPES.add(SWS_2009);
			KNOWN_ELEMENT_TYPES.add(OntologyMediatorRole_2008);
			KNOWN_ELEMENT_TYPES.add(OWLOntologyIncludes_4001);
			KNOWN_ELEMENT_TYPES.add(SemanticWebOrganizationKnowsOrg_4007);
			KNOWN_ELEMENT_TYPES.add(SWSDepends_on_4003);
			KNOWN_ELEMENT_TYPES.add(RoleKnowsRoleOnt_4004);
			KNOWN_ELEMENT_TYPES.add(RoleKnowsOrgOnt_4005);
			KNOWN_ELEMENT_TYPES.add(OntologyMediatorRoleKnowsService_4008);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case Ontology.diagram.edit.parts.OntologyViewpointEditPart.VISUAL_ID:
			return OntologyViewpoint_1000;
		case Ontology.diagram.edit.parts.RoleOntologyEditPart.VISUAL_ID:
			return RoleOntology_2001;
		case Ontology.diagram.edit.parts.OrganizationOntologyEditPart.VISUAL_ID:
			return OrganizationOntology_2002;
		case Ontology.diagram.edit.parts.ServiceOntologyEditPart.VISUAL_ID:
			return ServiceOntology_2003;
		case Ontology.diagram.edit.parts.BeliefEditPart.VISUAL_ID:
			return Belief_2004;
		case Ontology.diagram.edit.parts.FactEditPart.VISUAL_ID:
			return Fact_2005;
		case Ontology.diagram.edit.parts.SemanticWebOrganizationEditPart.VISUAL_ID:
			return SemanticWebOrganization_2006;
		case Ontology.diagram.edit.parts.RoleEditPart.VISUAL_ID:
			return Role_2007;
		case Ontology.diagram.edit.parts.SWSEditPart.VISUAL_ID:
			return SWS_2009;
		case Ontology.diagram.edit.parts.OntologyMediatorRoleEditPart.VISUAL_ID:
			return OntologyMediatorRole_2008;
		case Ontology.diagram.edit.parts.OWLOntologyIncludesEditPart.VISUAL_ID:
			return OWLOntologyIncludes_4001;
		case Ontology.diagram.edit.parts.SemanticWebOrganizationKnowsOrgEditPart.VISUAL_ID:
			return SemanticWebOrganizationKnowsOrg_4007;
		case Ontology.diagram.edit.parts.SWSDepends_onEditPart.VISUAL_ID:
			return SWSDepends_on_4003;
		case Ontology.diagram.edit.parts.RoleKnowsRoleOntEditPart.VISUAL_ID:
			return RoleKnowsRoleOnt_4004;
		case Ontology.diagram.edit.parts.RoleKnowsOrgOntEditPart.VISUAL_ID:
			return RoleKnowsOrgOnt_4005;
		case Ontology.diagram.edit.parts.OntologyMediatorRoleKnowsServiceEditPart.VISUAL_ID:
			return OntologyMediatorRoleKnowsService_4008;
		}
		return null;
	}

}
