/**
 */
package Ontology.provider;


import Ontology.OntologyFactory;
import Ontology.OntologyPackage;
import Ontology.OntologyViewpoint;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link Ontology.OntologyViewpoint} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class OntologyViewpointItemProvider
  extends ItemProviderAdapter
  implements
    IEditingDomainItemProvider,
    IStructuredItemContentProvider,
    ITreeItemContentProvider,
    IItemLabelProvider,
    IItemPropertySource
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OntologyViewpointItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

    }
    return itemPropertyDescriptors;
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_SEMANTIC_WEB_ORGANIZATION);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_ROLE_ONTOLOGY);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_ROLE);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_ORGANIZATION_ONTOLOGY);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_SERVICE_ONTOLOGY);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_SWS);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_ONTOLOGY_MEDIATOR_ROLE);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_BELIEF);
      childrenFeatures.add(OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_FACT);
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns OntologyViewpoint.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object getImage(Object object)
  {
    return overlayImage(object, getResourceLocator().getImage("full/obj16/OntologyViewpoint"));
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getText(Object object)
  {
    return getString("_UI_OntologyViewpoint_type");
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(OntologyViewpoint.class))
    {
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_SEMANTIC_WEB_ORGANIZATION:
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_ROLE_ONTOLOGY:
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_ROLE:
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_ORGANIZATION_ONTOLOGY:
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_SERVICE_ONTOLOGY:
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_SWS:
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_ONTOLOGY_MEDIATOR_ROLE:
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_BELIEF:
      case OntologyPackage.ONTOLOGY_VIEWPOINT__CONTAINS_FACT:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
   * that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_SEMANTIC_WEB_ORGANIZATION,
         OntologyFactory.eINSTANCE.createSemanticWebOrganization()));

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_ROLE_ONTOLOGY,
         OntologyFactory.eINSTANCE.createRoleOntology()));

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_ROLE,
         OntologyFactory.eINSTANCE.createRole()));

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_ORGANIZATION_ONTOLOGY,
         OntologyFactory.eINSTANCE.createOrganizationOntology()));

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_SERVICE_ONTOLOGY,
         OntologyFactory.eINSTANCE.createServiceOntology()));

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_SWS,
         OntologyFactory.eINSTANCE.createSWS()));

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_ONTOLOGY_MEDIATOR_ROLE,
         OntologyFactory.eINSTANCE.createOntologyMediatorRole()));

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_BELIEF,
         OntologyFactory.eINSTANCE.createBelief()));

    newChildDescriptors.add
      (createChildParameter
        (OntologyPackage.Literals.ONTOLOGY_VIEWPOINT__CONTAINS_FACT,
         OntologyFactory.eINSTANCE.createFact()));
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ResourceLocator getResourceLocator()
  {
    return OntologyEditPlugin.INSTANCE;
  }

}
