/**
 */
package Ontology;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see Ontology.OntologyFactory
 * @model kind="package"
 *        annotation="gmf foo='bar'"
 * @generated
 */
public interface OntologyPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "Ontology";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "/MyTest/model/Ontology.ecore";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "jfb.examples.gmf.Ontology";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  OntologyPackage eINSTANCE = Ontology.impl.OntologyPackageImpl.init();

  /**
   * The meta object id for the '{@link Ontology.impl.OntologyViewpointImpl <em>Viewpoint</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.OntologyViewpointImpl
   * @see Ontology.impl.OntologyPackageImpl#getOntologyViewpoint()
   * @generated
   */
  int ONTOLOGY_VIEWPOINT = 0;

  /**
   * The feature id for the '<em><b>Contains Semantic Web Organization</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_SEMANTIC_WEB_ORGANIZATION = 0;

  /**
   * The feature id for the '<em><b>Contains Role Ontology</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_ROLE_ONTOLOGY = 1;

  /**
   * The feature id for the '<em><b>Contains Role</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_ROLE = 2;

  /**
   * The feature id for the '<em><b>Contains Organization Ontology</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_ORGANIZATION_ONTOLOGY = 3;

  /**
   * The feature id for the '<em><b>Contains Service Ontology</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_SERVICE_ONTOLOGY = 4;

  /**
   * The feature id for the '<em><b>Contains SWS</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_SWS = 5;

  /**
   * The feature id for the '<em><b>Contains Ontology Mediator Role</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_ONTOLOGY_MEDIATOR_ROLE = 6;

  /**
   * The feature id for the '<em><b>Contains Belief</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_BELIEF = 7;

  /**
   * The feature id for the '<em><b>Contains Fact</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT__CONTAINS_FACT = 8;

  /**
   * The number of structural features of the '<em>Viewpoint</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_VIEWPOINT_FEATURE_COUNT = 9;

  /**
   * The meta object id for the '{@link Ontology.impl.OWLOntologyImpl <em>OWL Ontology</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.OWLOntologyImpl
   * @see Ontology.impl.OntologyPackageImpl#getOWLOntology()
   * @generated
   */
  int OWL_ONTOLOGY = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OWL_ONTOLOGY__NAME = 0;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OWL_ONTOLOGY__DESCRIPTION = 1;

  /**
   * The feature id for the '<em><b>Includes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OWL_ONTOLOGY__INCLUDES = 2;

  /**
   * The number of structural features of the '<em>OWL Ontology</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OWL_ONTOLOGY_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link Ontology.impl.OrganizationOntologyImpl <em>Organization Ontology</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.OrganizationOntologyImpl
   * @see Ontology.impl.OntologyPackageImpl#getOrganizationOntology()
   * @generated
   */
  int ORGANIZATION_ONTOLOGY = 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ORGANIZATION_ONTOLOGY__NAME = OWL_ONTOLOGY__NAME;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ORGANIZATION_ONTOLOGY__DESCRIPTION = OWL_ONTOLOGY__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Includes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ORGANIZATION_ONTOLOGY__INCLUDES = OWL_ONTOLOGY__INCLUDES;

  /**
   * The feature id for the '<em><b>Orgontname</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ORGANIZATION_ONTOLOGY__ORGONTNAME = OWL_ONTOLOGY_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Organization Ontology</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ORGANIZATION_ONTOLOGY_FEATURE_COUNT = OWL_ONTOLOGY_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link Ontology.impl.SemanticWebOrganizationImpl <em>Semantic Web Organization</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.SemanticWebOrganizationImpl
   * @see Ontology.impl.OntologyPackageImpl#getSemanticWebOrganization()
   * @generated
   */
  int SEMANTIC_WEB_ORGANIZATION = 3;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_ORGANIZATION__NAME = 0;

  /**
   * The feature id for the '<em><b>Knows Org</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_ORGANIZATION__KNOWS_ORG = 1;

  /**
   * The number of structural features of the '<em>Semantic Web Organization</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEMANTIC_WEB_ORGANIZATION_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link Ontology.impl.RoleOntologyImpl <em>Role Ontology</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.RoleOntologyImpl
   * @see Ontology.impl.OntologyPackageImpl#getRoleOntology()
   * @generated
   */
  int ROLE_ONTOLOGY = 4;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_ONTOLOGY__NAME = OWL_ONTOLOGY__NAME;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_ONTOLOGY__DESCRIPTION = OWL_ONTOLOGY__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Includes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_ONTOLOGY__INCLUDES = OWL_ONTOLOGY__INCLUDES;

  /**
   * The feature id for the '<em><b>Rname</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_ONTOLOGY__RNAME = OWL_ONTOLOGY_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Role Ontology</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_ONTOLOGY_FEATURE_COUNT = OWL_ONTOLOGY_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link Ontology.impl.ServiceOntologyImpl <em>Service Ontology</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.ServiceOntologyImpl
   * @see Ontology.impl.OntologyPackageImpl#getServiceOntology()
   * @generated
   */
  int SERVICE_ONTOLOGY = 5;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SERVICE_ONTOLOGY__NAME = OWL_ONTOLOGY__NAME;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SERVICE_ONTOLOGY__DESCRIPTION = OWL_ONTOLOGY__DESCRIPTION;

  /**
   * The feature id for the '<em><b>Includes</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SERVICE_ONTOLOGY__INCLUDES = OWL_ONTOLOGY__INCLUDES;

  /**
   * The feature id for the '<em><b>Sname</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SERVICE_ONTOLOGY__SNAME = OWL_ONTOLOGY_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Service Ontology</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SERVICE_ONTOLOGY_FEATURE_COUNT = OWL_ONTOLOGY_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link Ontology.impl.SWSImpl <em>SWS</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.SWSImpl
   * @see Ontology.impl.OntologyPackageImpl#getSWS()
   * @generated
   */
  int SWS = 6;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SWS__NAME = 0;

  /**
   * The feature id for the '<em><b>Depends on</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SWS__DEPENDS_ON = 1;

  /**
   * The number of structural features of the '<em>SWS</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SWS_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link Ontology.impl.RoleImpl <em>Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.RoleImpl
   * @see Ontology.impl.OntologyPackageImpl#getRole()
   * @generated
   */
  int ROLE = 7;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__NAME = 0;

  /**
   * The feature id for the '<em><b>Knows Role Ont</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__KNOWS_ROLE_ONT = 1;

  /**
   * The feature id for the '<em><b>Knows Org Ont</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__KNOWS_ORG_ONT = 2;

  /**
   * The number of structural features of the '<em>Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link Ontology.impl.OntologyMediatorRoleImpl <em>Mediator Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.OntologyMediatorRoleImpl
   * @see Ontology.impl.OntologyPackageImpl#getOntologyMediatorRole()
   * @generated
   */
  int ONTOLOGY_MEDIATOR_ROLE = 8;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_MEDIATOR_ROLE__NAME = 0;

  /**
   * The feature id for the '<em><b>Knows Service</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_MEDIATOR_ROLE__KNOWS_SERVICE = 1;

  /**
   * The number of structural features of the '<em>Mediator Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ONTOLOGY_MEDIATOR_ROLE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link Ontology.impl.ODMOWLStatementImpl <em>ODMOWL Statement</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.ODMOWLStatementImpl
   * @see Ontology.impl.OntologyPackageImpl#getODMOWLStatement()
   * @generated
   */
  int ODMOWL_STATEMENT = 11;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ODMOWL_STATEMENT__NAME = 0;

  /**
   * The number of structural features of the '<em>ODMOWL Statement</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ODMOWL_STATEMENT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link Ontology.impl.BeliefImpl <em>Belief</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.BeliefImpl
   * @see Ontology.impl.OntologyPackageImpl#getBelief()
   * @generated
   */
  int BELIEF = 9;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BELIEF__NAME = ODMOWL_STATEMENT__NAME;

  /**
   * The feature id for the '<em><b>Bname</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BELIEF__BNAME = ODMOWL_STATEMENT_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BELIEF__DESCRIPTION = ODMOWL_STATEMENT_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Dynamic</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BELIEF__DYNAMIC = ODMOWL_STATEMENT_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Belief</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BELIEF_FEATURE_COUNT = ODMOWL_STATEMENT_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link Ontology.impl.FactImpl <em>Fact</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Ontology.impl.FactImpl
   * @see Ontology.impl.OntologyPackageImpl#getFact()
   * @generated
   */
  int FACT = 10;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACT__NAME = ODMOWL_STATEMENT__NAME;

  /**
   * The feature id for the '<em><b>Fname</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACT__FNAME = ODMOWL_STATEMENT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Fact</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACT_FEATURE_COUNT = ODMOWL_STATEMENT_FEATURE_COUNT + 1;


  /**
   * Returns the meta object for class '{@link Ontology.OntologyViewpoint <em>Viewpoint</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Viewpoint</em>'.
   * @see Ontology.OntologyViewpoint
   * @generated
   */
  EClass getOntologyViewpoint();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsSemanticWebOrganization <em>Contains Semantic Web Organization</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains Semantic Web Organization</em>'.
   * @see Ontology.OntologyViewpoint#getContainsSemanticWebOrganization()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsSemanticWebOrganization();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsRoleOntology <em>Contains Role Ontology</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains Role Ontology</em>'.
   * @see Ontology.OntologyViewpoint#getContainsRoleOntology()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsRoleOntology();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsRole <em>Contains Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains Role</em>'.
   * @see Ontology.OntologyViewpoint#getContainsRole()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsRole();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsOrganizationOntology <em>Contains Organization Ontology</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains Organization Ontology</em>'.
   * @see Ontology.OntologyViewpoint#getContainsOrganizationOntology()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsOrganizationOntology();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsServiceOntology <em>Contains Service Ontology</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains Service Ontology</em>'.
   * @see Ontology.OntologyViewpoint#getContainsServiceOntology()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsServiceOntology();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsSWS <em>Contains SWS</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains SWS</em>'.
   * @see Ontology.OntologyViewpoint#getContainsSWS()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsSWS();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsOntologyMediatorRole <em>Contains Ontology Mediator Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains Ontology Mediator Role</em>'.
   * @see Ontology.OntologyViewpoint#getContainsOntologyMediatorRole()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsOntologyMediatorRole();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsBelief <em>Contains Belief</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains Belief</em>'.
   * @see Ontology.OntologyViewpoint#getContainsBelief()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsBelief();

  /**
   * Returns the meta object for the containment reference list '{@link Ontology.OntologyViewpoint#getContainsFact <em>Contains Fact</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contains Fact</em>'.
   * @see Ontology.OntologyViewpoint#getContainsFact()
   * @see #getOntologyViewpoint()
   * @generated
   */
  EReference getOntologyViewpoint_ContainsFact();

  /**
   * Returns the meta object for class '{@link Ontology.OrganizationOntology <em>Organization Ontology</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Organization Ontology</em>'.
   * @see Ontology.OrganizationOntology
   * @generated
   */
  EClass getOrganizationOntology();

  /**
   * Returns the meta object for the attribute '{@link Ontology.OrganizationOntology#getOrgontname <em>Orgontname</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Orgontname</em>'.
   * @see Ontology.OrganizationOntology#getOrgontname()
   * @see #getOrganizationOntology()
   * @generated
   */
  EAttribute getOrganizationOntology_Orgontname();

  /**
   * Returns the meta object for class '{@link Ontology.OWLOntology <em>OWL Ontology</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>OWL Ontology</em>'.
   * @see Ontology.OWLOntology
   * @generated
   */
  EClass getOWLOntology();

  /**
   * Returns the meta object for the attribute '{@link Ontology.OWLOntology#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see Ontology.OWLOntology#getName()
   * @see #getOWLOntology()
   * @generated
   */
  EAttribute getOWLOntology_Name();

  /**
   * Returns the meta object for the attribute '{@link Ontology.OWLOntology#getDescription <em>Description</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Description</em>'.
   * @see Ontology.OWLOntology#getDescription()
   * @see #getOWLOntology()
   * @generated
   */
  EAttribute getOWLOntology_Description();

  /**
   * Returns the meta object for the reference list '{@link Ontology.OWLOntology#getIncludes <em>Includes</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Includes</em>'.
   * @see Ontology.OWLOntology#getIncludes()
   * @see #getOWLOntology()
   * @generated
   */
  EReference getOWLOntology_Includes();

  /**
   * Returns the meta object for class '{@link Ontology.SemanticWebOrganization <em>Semantic Web Organization</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Semantic Web Organization</em>'.
   * @see Ontology.SemanticWebOrganization
   * @generated
   */
  EClass getSemanticWebOrganization();

  /**
   * Returns the meta object for the attribute '{@link Ontology.SemanticWebOrganization#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see Ontology.SemanticWebOrganization#getName()
   * @see #getSemanticWebOrganization()
   * @generated
   */
  EAttribute getSemanticWebOrganization_Name();

  /**
   * Returns the meta object for the reference list '{@link Ontology.SemanticWebOrganization#getKnowsOrg <em>Knows Org</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Knows Org</em>'.
   * @see Ontology.SemanticWebOrganization#getKnowsOrg()
   * @see #getSemanticWebOrganization()
   * @generated
   */
  EReference getSemanticWebOrganization_KnowsOrg();

  /**
   * Returns the meta object for class '{@link Ontology.RoleOntology <em>Role Ontology</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Role Ontology</em>'.
   * @see Ontology.RoleOntology
   * @generated
   */
  EClass getRoleOntology();

  /**
   * Returns the meta object for the attribute '{@link Ontology.RoleOntology#getRname <em>Rname</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Rname</em>'.
   * @see Ontology.RoleOntology#getRname()
   * @see #getRoleOntology()
   * @generated
   */
  EAttribute getRoleOntology_Rname();

  /**
   * Returns the meta object for class '{@link Ontology.ServiceOntology <em>Service Ontology</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Service Ontology</em>'.
   * @see Ontology.ServiceOntology
   * @generated
   */
  EClass getServiceOntology();

  /**
   * Returns the meta object for the attribute '{@link Ontology.ServiceOntology#getSname <em>Sname</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Sname</em>'.
   * @see Ontology.ServiceOntology#getSname()
   * @see #getServiceOntology()
   * @generated
   */
  EAttribute getServiceOntology_Sname();

  /**
   * Returns the meta object for class '{@link Ontology.SWS <em>SWS</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>SWS</em>'.
   * @see Ontology.SWS
   * @generated
   */
  EClass getSWS();

  /**
   * Returns the meta object for the attribute '{@link Ontology.SWS#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see Ontology.SWS#getName()
   * @see #getSWS()
   * @generated
   */
  EAttribute getSWS_Name();

  /**
   * Returns the meta object for the reference '{@link Ontology.SWS#getDepends_on <em>Depends on</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Depends on</em>'.
   * @see Ontology.SWS#getDepends_on()
   * @see #getSWS()
   * @generated
   */
  EReference getSWS_Depends_on();

  /**
   * Returns the meta object for class '{@link Ontology.Role <em>Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Role</em>'.
   * @see Ontology.Role
   * @generated
   */
  EClass getRole();

  /**
   * Returns the meta object for the attribute '{@link Ontology.Role#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see Ontology.Role#getName()
   * @see #getRole()
   * @generated
   */
  EAttribute getRole_Name();

  /**
   * Returns the meta object for the reference list '{@link Ontology.Role#getKnowsRoleOnt <em>Knows Role Ont</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Knows Role Ont</em>'.
   * @see Ontology.Role#getKnowsRoleOnt()
   * @see #getRole()
   * @generated
   */
  EReference getRole_KnowsRoleOnt();

  /**
   * Returns the meta object for the reference list '{@link Ontology.Role#getKnowsOrgOnt <em>Knows Org Ont</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Knows Org Ont</em>'.
   * @see Ontology.Role#getKnowsOrgOnt()
   * @see #getRole()
   * @generated
   */
  EReference getRole_KnowsOrgOnt();

  /**
   * Returns the meta object for class '{@link Ontology.OntologyMediatorRole <em>Mediator Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Mediator Role</em>'.
   * @see Ontology.OntologyMediatorRole
   * @generated
   */
  EClass getOntologyMediatorRole();

  /**
   * Returns the meta object for the attribute '{@link Ontology.OntologyMediatorRole#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see Ontology.OntologyMediatorRole#getName()
   * @see #getOntologyMediatorRole()
   * @generated
   */
  EAttribute getOntologyMediatorRole_Name();

  /**
   * Returns the meta object for the reference '{@link Ontology.OntologyMediatorRole#getKnowsService <em>Knows Service</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Knows Service</em>'.
   * @see Ontology.OntologyMediatorRole#getKnowsService()
   * @see #getOntologyMediatorRole()
   * @generated
   */
  EReference getOntologyMediatorRole_KnowsService();

  /**
   * Returns the meta object for class '{@link Ontology.Belief <em>Belief</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Belief</em>'.
   * @see Ontology.Belief
   * @generated
   */
  EClass getBelief();

  /**
   * Returns the meta object for the attribute '{@link Ontology.Belief#getBname <em>Bname</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Bname</em>'.
   * @see Ontology.Belief#getBname()
   * @see #getBelief()
   * @generated
   */
  EAttribute getBelief_Bname();

  /**
   * Returns the meta object for the attribute '{@link Ontology.Belief#getDescription <em>Description</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Description</em>'.
   * @see Ontology.Belief#getDescription()
   * @see #getBelief()
   * @generated
   */
  EAttribute getBelief_Description();

  /**
   * Returns the meta object for the attribute '{@link Ontology.Belief#isDynamic <em>Dynamic</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Dynamic</em>'.
   * @see Ontology.Belief#isDynamic()
   * @see #getBelief()
   * @generated
   */
  EAttribute getBelief_Dynamic();

  /**
   * Returns the meta object for class '{@link Ontology.Fact <em>Fact</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Fact</em>'.
   * @see Ontology.Fact
   * @generated
   */
  EClass getFact();

  /**
   * Returns the meta object for the attribute '{@link Ontology.Fact#getFname <em>Fname</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Fname</em>'.
   * @see Ontology.Fact#getFname()
   * @see #getFact()
   * @generated
   */
  EAttribute getFact_Fname();

  /**
   * Returns the meta object for class '{@link Ontology.ODMOWLStatement <em>ODMOWL Statement</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>ODMOWL Statement</em>'.
   * @see Ontology.ODMOWLStatement
   * @generated
   */
  EClass getODMOWLStatement();

  /**
   * Returns the meta object for the attribute '{@link Ontology.ODMOWLStatement#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see Ontology.ODMOWLStatement#getName()
   * @see #getODMOWLStatement()
   * @generated
   */
  EAttribute getODMOWLStatement_Name();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  OntologyFactory getOntologyFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link Ontology.impl.OntologyViewpointImpl <em>Viewpoint</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.OntologyViewpointImpl
     * @see Ontology.impl.OntologyPackageImpl#getOntologyViewpoint()
     * @generated
     */
    EClass ONTOLOGY_VIEWPOINT = eINSTANCE.getOntologyViewpoint();

    /**
     * The meta object literal for the '<em><b>Contains Semantic Web Organization</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_SEMANTIC_WEB_ORGANIZATION = eINSTANCE.getOntologyViewpoint_ContainsSemanticWebOrganization();

    /**
     * The meta object literal for the '<em><b>Contains Role Ontology</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_ROLE_ONTOLOGY = eINSTANCE.getOntologyViewpoint_ContainsRoleOntology();

    /**
     * The meta object literal for the '<em><b>Contains Role</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_ROLE = eINSTANCE.getOntologyViewpoint_ContainsRole();

    /**
     * The meta object literal for the '<em><b>Contains Organization Ontology</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_ORGANIZATION_ONTOLOGY = eINSTANCE.getOntologyViewpoint_ContainsOrganizationOntology();

    /**
     * The meta object literal for the '<em><b>Contains Service Ontology</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_SERVICE_ONTOLOGY = eINSTANCE.getOntologyViewpoint_ContainsServiceOntology();

    /**
     * The meta object literal for the '<em><b>Contains SWS</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_SWS = eINSTANCE.getOntologyViewpoint_ContainsSWS();

    /**
     * The meta object literal for the '<em><b>Contains Ontology Mediator Role</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_ONTOLOGY_MEDIATOR_ROLE = eINSTANCE.getOntologyViewpoint_ContainsOntologyMediatorRole();

    /**
     * The meta object literal for the '<em><b>Contains Belief</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_BELIEF = eINSTANCE.getOntologyViewpoint_ContainsBelief();

    /**
     * The meta object literal for the '<em><b>Contains Fact</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_VIEWPOINT__CONTAINS_FACT = eINSTANCE.getOntologyViewpoint_ContainsFact();

    /**
     * The meta object literal for the '{@link Ontology.impl.OrganizationOntologyImpl <em>Organization Ontology</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.OrganizationOntologyImpl
     * @see Ontology.impl.OntologyPackageImpl#getOrganizationOntology()
     * @generated
     */
    EClass ORGANIZATION_ONTOLOGY = eINSTANCE.getOrganizationOntology();

    /**
     * The meta object literal for the '<em><b>Orgontname</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ORGANIZATION_ONTOLOGY__ORGONTNAME = eINSTANCE.getOrganizationOntology_Orgontname();

    /**
     * The meta object literal for the '{@link Ontology.impl.OWLOntologyImpl <em>OWL Ontology</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.OWLOntologyImpl
     * @see Ontology.impl.OntologyPackageImpl#getOWLOntology()
     * @generated
     */
    EClass OWL_ONTOLOGY = eINSTANCE.getOWLOntology();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute OWL_ONTOLOGY__NAME = eINSTANCE.getOWLOntology_Name();

    /**
     * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute OWL_ONTOLOGY__DESCRIPTION = eINSTANCE.getOWLOntology_Description();

    /**
     * The meta object literal for the '<em><b>Includes</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference OWL_ONTOLOGY__INCLUDES = eINSTANCE.getOWLOntology_Includes();

    /**
     * The meta object literal for the '{@link Ontology.impl.SemanticWebOrganizationImpl <em>Semantic Web Organization</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.SemanticWebOrganizationImpl
     * @see Ontology.impl.OntologyPackageImpl#getSemanticWebOrganization()
     * @generated
     */
    EClass SEMANTIC_WEB_ORGANIZATION = eINSTANCE.getSemanticWebOrganization();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SEMANTIC_WEB_ORGANIZATION__NAME = eINSTANCE.getSemanticWebOrganization_Name();

    /**
     * The meta object literal for the '<em><b>Knows Org</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SEMANTIC_WEB_ORGANIZATION__KNOWS_ORG = eINSTANCE.getSemanticWebOrganization_KnowsOrg();

    /**
     * The meta object literal for the '{@link Ontology.impl.RoleOntologyImpl <em>Role Ontology</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.RoleOntologyImpl
     * @see Ontology.impl.OntologyPackageImpl#getRoleOntology()
     * @generated
     */
    EClass ROLE_ONTOLOGY = eINSTANCE.getRoleOntology();

    /**
     * The meta object literal for the '<em><b>Rname</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ROLE_ONTOLOGY__RNAME = eINSTANCE.getRoleOntology_Rname();

    /**
     * The meta object literal for the '{@link Ontology.impl.ServiceOntologyImpl <em>Service Ontology</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.ServiceOntologyImpl
     * @see Ontology.impl.OntologyPackageImpl#getServiceOntology()
     * @generated
     */
    EClass SERVICE_ONTOLOGY = eINSTANCE.getServiceOntology();

    /**
     * The meta object literal for the '<em><b>Sname</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SERVICE_ONTOLOGY__SNAME = eINSTANCE.getServiceOntology_Sname();

    /**
     * The meta object literal for the '{@link Ontology.impl.SWSImpl <em>SWS</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.SWSImpl
     * @see Ontology.impl.OntologyPackageImpl#getSWS()
     * @generated
     */
    EClass SWS = eINSTANCE.getSWS();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SWS__NAME = eINSTANCE.getSWS_Name();

    /**
     * The meta object literal for the '<em><b>Depends on</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SWS__DEPENDS_ON = eINSTANCE.getSWS_Depends_on();

    /**
     * The meta object literal for the '{@link Ontology.impl.RoleImpl <em>Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.RoleImpl
     * @see Ontology.impl.OntologyPackageImpl#getRole()
     * @generated
     */
    EClass ROLE = eINSTANCE.getRole();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ROLE__NAME = eINSTANCE.getRole_Name();

    /**
     * The meta object literal for the '<em><b>Knows Role Ont</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE__KNOWS_ROLE_ONT = eINSTANCE.getRole_KnowsRoleOnt();

    /**
     * The meta object literal for the '<em><b>Knows Org Ont</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ROLE__KNOWS_ORG_ONT = eINSTANCE.getRole_KnowsOrgOnt();

    /**
     * The meta object literal for the '{@link Ontology.impl.OntologyMediatorRoleImpl <em>Mediator Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.OntologyMediatorRoleImpl
     * @see Ontology.impl.OntologyPackageImpl#getOntologyMediatorRole()
     * @generated
     */
    EClass ONTOLOGY_MEDIATOR_ROLE = eINSTANCE.getOntologyMediatorRole();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ONTOLOGY_MEDIATOR_ROLE__NAME = eINSTANCE.getOntologyMediatorRole_Name();

    /**
     * The meta object literal for the '<em><b>Knows Service</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ONTOLOGY_MEDIATOR_ROLE__KNOWS_SERVICE = eINSTANCE.getOntologyMediatorRole_KnowsService();

    /**
     * The meta object literal for the '{@link Ontology.impl.BeliefImpl <em>Belief</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.BeliefImpl
     * @see Ontology.impl.OntologyPackageImpl#getBelief()
     * @generated
     */
    EClass BELIEF = eINSTANCE.getBelief();

    /**
     * The meta object literal for the '<em><b>Bname</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute BELIEF__BNAME = eINSTANCE.getBelief_Bname();

    /**
     * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute BELIEF__DESCRIPTION = eINSTANCE.getBelief_Description();

    /**
     * The meta object literal for the '<em><b>Dynamic</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute BELIEF__DYNAMIC = eINSTANCE.getBelief_Dynamic();

    /**
     * The meta object literal for the '{@link Ontology.impl.FactImpl <em>Fact</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.FactImpl
     * @see Ontology.impl.OntologyPackageImpl#getFact()
     * @generated
     */
    EClass FACT = eINSTANCE.getFact();

    /**
     * The meta object literal for the '<em><b>Fname</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FACT__FNAME = eINSTANCE.getFact_Fname();

    /**
     * The meta object literal for the '{@link Ontology.impl.ODMOWLStatementImpl <em>ODMOWL Statement</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Ontology.impl.ODMOWLStatementImpl
     * @see Ontology.impl.OntologyPackageImpl#getODMOWLStatement()
     * @generated
     */
    EClass ODMOWL_STATEMENT = eINSTANCE.getODMOWLStatement();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ODMOWL_STATEMENT__NAME = eINSTANCE.getODMOWLStatement_Name();

  }

} //OntologyPackage
