/**
 */
package plan;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see plan.PlanFactory
 * @model kind="package"
 * @generated
 */
public interface PlanPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "plan";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "plan";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "plan";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  PlanPackage eINSTANCE = plan.impl.PlanPackageImpl.init();

  /**
   * The meta object id for the '{@link plan.impl.PlanPalleteImpl <em>Pallete</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see plan.impl.PlanPalleteImpl
   * @see plan.impl.PlanPackageImpl#getPlanPallete()
   * @generated
   */
  int PLAN_PALLETE = 0;

  /**
   * The feature id for the '<em><b>Plans</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN_PALLETE__PLANS = 0;

  /**
   * The feature id for the '<em><b>Msgs</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN_PALLETE__MSGS = 1;

  /**
   * The number of structural features of the '<em>Pallete</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN_PALLETE_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link plan.impl.PlanImpl <em>Plan</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see plan.impl.PlanImpl
   * @see plan.impl.PlanPackageImpl#getPlan()
   * @generated
   */
  int PLAN = 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN__NAME = 0;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN__TYPE = 1;

  /**
   * The feature id for the '<em><b>Composed of</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN__COMPOSED_OF = 2;

  /**
   * The feature id for the '<em><b>Description</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN__DESCRIPTION = 3;

  /**
   * The feature id for the '<em><b>Priority</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN__PRIORITY = 4;

  /**
   * The number of structural features of the '<em>Plan</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAN_FEATURE_COUNT = 5;

  /**
   * The meta object id for the '{@link plan.impl.TaskImpl <em>Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see plan.impl.TaskImpl
   * @see plan.impl.PlanPackageImpl#getTask()
   * @generated
   */
  int TASK = 2;

  /**
   * The feature id for the '<em><b>Name0</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__NAME0 = 0;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__ID = 1;

  /**
   * The feature id for the '<em><b>Composed of</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__COMPOSED_OF = 2;

  /**
   * The number of structural features of the '<em>Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link plan.impl.ActionImpl <em>Action</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see plan.impl.ActionImpl
   * @see plan.impl.PlanPackageImpl#getAction()
   * @generated
   */
  int ACTION = 3;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTION__ID = 0;

  /**
   * The feature id for the '<em><b>Name1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTION__NAME1 = 1;

  /**
   * The number of structural features of the '<em>Action</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTION_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link plan.impl.SendImpl <em>Send</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see plan.impl.SendImpl
   * @see plan.impl.PlanPackageImpl#getSend()
   * @generated
   */
  int SEND = 4;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEND__ID = ACTION__ID;

  /**
   * The feature id for the '<em><b>Name1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEND__NAME1 = ACTION__NAME1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEND__NAME = ACTION_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Send</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEND__SEND = ACTION_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Send</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SEND_FEATURE_COUNT = ACTION_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link plan.impl.ReceiveImpl <em>Receive</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see plan.impl.ReceiveImpl
   * @see plan.impl.PlanPackageImpl#getReceive()
   * @generated
   */
  int RECEIVE = 5;

  /**
   * The feature id for the '<em><b>Id</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RECEIVE__ID = ACTION__ID;

  /**
   * The feature id for the '<em><b>Name1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RECEIVE__NAME1 = ACTION__NAME1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RECEIVE__NAME = ACTION_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Receive</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RECEIVE__RECEIVE = ACTION_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Receive</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RECEIVE_FEATURE_COUNT = ACTION_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link plan.impl.MessageImpl <em>Message</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see plan.impl.MessageImpl
   * @see plan.impl.PlanPackageImpl#getMessage()
   * @generated
   */
  int MESSAGE = 6;

  /**
   * The feature id for the '<em><b>Name2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__NAME2 = 0;

  /**
   * The feature id for the '<em><b>Sender</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__SENDER = 1;

  /**
   * The feature id for the '<em><b>Receiver</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__RECEIVER = 2;

  /**
   * The feature id for the '<em><b>Performative</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__PERFORMATIVE = 3;

  /**
   * The feature id for the '<em><b>Msg Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__MSG_TYPE = 4;

  /**
   * The feature id for the '<em><b>Content</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE__CONTENT = 5;

  /**
   * The number of structural features of the '<em>Message</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MESSAGE_FEATURE_COUNT = 6;


  /**
   * Returns the meta object for class '{@link plan.PlanPallete <em>Pallete</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Pallete</em>'.
   * @see plan.PlanPallete
   * @generated
   */
  EClass getPlanPallete();

  /**
   * Returns the meta object for the containment reference list '{@link plan.PlanPallete#getPlans <em>Plans</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Plans</em>'.
   * @see plan.PlanPallete#getPlans()
   * @see #getPlanPallete()
   * @generated
   */
  EReference getPlanPallete_Plans();

  /**
   * Returns the meta object for the containment reference list '{@link plan.PlanPallete#getMsgs <em>Msgs</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Msgs</em>'.
   * @see plan.PlanPallete#getMsgs()
   * @see #getPlanPallete()
   * @generated
   */
  EReference getPlanPallete_Msgs();

  /**
   * Returns the meta object for class '{@link plan.Plan <em>Plan</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Plan</em>'.
   * @see plan.Plan
   * @generated
   */
  EClass getPlan();

  /**
   * Returns the meta object for the attribute '{@link plan.Plan#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see plan.Plan#getName()
   * @see #getPlan()
   * @generated
   */
  EAttribute getPlan_Name();

  /**
   * Returns the meta object for the attribute '{@link plan.Plan#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see plan.Plan#getType()
   * @see #getPlan()
   * @generated
   */
  EAttribute getPlan_Type();

  /**
   * Returns the meta object for the containment reference list '{@link plan.Plan#getComposed_of <em>Composed of</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Composed of</em>'.
   * @see plan.Plan#getComposed_of()
   * @see #getPlan()
   * @generated
   */
  EReference getPlan_Composed_of();

  /**
   * Returns the meta object for the attribute '{@link plan.Plan#getDescription <em>Description</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Description</em>'.
   * @see plan.Plan#getDescription()
   * @see #getPlan()
   * @generated
   */
  EAttribute getPlan_Description();

  /**
   * Returns the meta object for the attribute '{@link plan.Plan#getPriority <em>Priority</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Priority</em>'.
   * @see plan.Plan#getPriority()
   * @see #getPlan()
   * @generated
   */
  EAttribute getPlan_Priority();

  /**
   * Returns the meta object for class '{@link plan.Task <em>Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Task</em>'.
   * @see plan.Task
   * @generated
   */
  EClass getTask();

  /**
   * Returns the meta object for the attribute '{@link plan.Task#getName0 <em>Name0</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name0</em>'.
   * @see plan.Task#getName0()
   * @see #getTask()
   * @generated
   */
  EAttribute getTask_Name0();

  /**
   * Returns the meta object for the attribute '{@link plan.Task#getId <em>Id</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Id</em>'.
   * @see plan.Task#getId()
   * @see #getTask()
   * @generated
   */
  EAttribute getTask_Id();

  /**
   * Returns the meta object for the containment reference list '{@link plan.Task#getComposed_of <em>Composed of</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Composed of</em>'.
   * @see plan.Task#getComposed_of()
   * @see #getTask()
   * @generated
   */
  EReference getTask_Composed_of();

  /**
   * Returns the meta object for class '{@link plan.Action <em>Action</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Action</em>'.
   * @see plan.Action
   * @generated
   */
  EClass getAction();

  /**
   * Returns the meta object for the attribute '{@link plan.Action#getId <em>Id</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Id</em>'.
   * @see plan.Action#getId()
   * @see #getAction()
   * @generated
   */
  EAttribute getAction_Id();

  /**
   * Returns the meta object for the attribute '{@link plan.Action#getName1 <em>Name1</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name1</em>'.
   * @see plan.Action#getName1()
   * @see #getAction()
   * @generated
   */
  EAttribute getAction_Name1();

  /**
   * Returns the meta object for class '{@link plan.Send <em>Send</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Send</em>'.
   * @see plan.Send
   * @generated
   */
  EClass getSend();

  /**
   * Returns the meta object for the attribute '{@link plan.Send#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see plan.Send#getName()
   * @see #getSend()
   * @generated
   */
  EAttribute getSend_Name();

  /**
   * Returns the meta object for the reference '{@link plan.Send#getSend <em>Send</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Send</em>'.
   * @see plan.Send#getSend()
   * @see #getSend()
   * @generated
   */
  EReference getSend_Send();

  /**
   * Returns the meta object for class '{@link plan.Receive <em>Receive</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Receive</em>'.
   * @see plan.Receive
   * @generated
   */
  EClass getReceive();

  /**
   * Returns the meta object for the attribute '{@link plan.Receive#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see plan.Receive#getName()
   * @see #getReceive()
   * @generated
   */
  EAttribute getReceive_Name();

  /**
   * Returns the meta object for the reference '{@link plan.Receive#getReceive <em>Receive</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Receive</em>'.
   * @see plan.Receive#getReceive()
   * @see #getReceive()
   * @generated
   */
  EReference getReceive_Receive();

  /**
   * Returns the meta object for class '{@link plan.Message <em>Message</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Message</em>'.
   * @see plan.Message
   * @generated
   */
  EClass getMessage();

  /**
   * Returns the meta object for the attribute '{@link plan.Message#getName2 <em>Name2</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name2</em>'.
   * @see plan.Message#getName2()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Name2();

  /**
   * Returns the meta object for the attribute '{@link plan.Message#getSender <em>Sender</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Sender</em>'.
   * @see plan.Message#getSender()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Sender();

  /**
   * Returns the meta object for the attribute '{@link plan.Message#getReceiver <em>Receiver</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Receiver</em>'.
   * @see plan.Message#getReceiver()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Receiver();

  /**
   * Returns the meta object for the attribute '{@link plan.Message#getPerformative <em>Performative</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Performative</em>'.
   * @see plan.Message#getPerformative()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Performative();

  /**
   * Returns the meta object for the attribute '{@link plan.Message#getMsgType <em>Msg Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Msg Type</em>'.
   * @see plan.Message#getMsgType()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_MsgType();

  /**
   * Returns the meta object for the attribute '{@link plan.Message#getContent <em>Content</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Content</em>'.
   * @see plan.Message#getContent()
   * @see #getMessage()
   * @generated
   */
  EAttribute getMessage_Content();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  PlanFactory getPlanFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link plan.impl.PlanPalleteImpl <em>Pallete</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see plan.impl.PlanPalleteImpl
     * @see plan.impl.PlanPackageImpl#getPlanPallete()
     * @generated
     */
    EClass PLAN_PALLETE = eINSTANCE.getPlanPallete();

    /**
     * The meta object literal for the '<em><b>Plans</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PLAN_PALLETE__PLANS = eINSTANCE.getPlanPallete_Plans();

    /**
     * The meta object literal for the '<em><b>Msgs</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PLAN_PALLETE__MSGS = eINSTANCE.getPlanPallete_Msgs();

    /**
     * The meta object literal for the '{@link plan.impl.PlanImpl <em>Plan</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see plan.impl.PlanImpl
     * @see plan.impl.PlanPackageImpl#getPlan()
     * @generated
     */
    EClass PLAN = eINSTANCE.getPlan();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PLAN__NAME = eINSTANCE.getPlan_Name();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PLAN__TYPE = eINSTANCE.getPlan_Type();

    /**
     * The meta object literal for the '<em><b>Composed of</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PLAN__COMPOSED_OF = eINSTANCE.getPlan_Composed_of();

    /**
     * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PLAN__DESCRIPTION = eINSTANCE.getPlan_Description();

    /**
     * The meta object literal for the '<em><b>Priority</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PLAN__PRIORITY = eINSTANCE.getPlan_Priority();

    /**
     * The meta object literal for the '{@link plan.impl.TaskImpl <em>Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see plan.impl.TaskImpl
     * @see plan.impl.PlanPackageImpl#getTask()
     * @generated
     */
    EClass TASK = eINSTANCE.getTask();

    /**
     * The meta object literal for the '<em><b>Name0</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute TASK__NAME0 = eINSTANCE.getTask_Name0();

    /**
     * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute TASK__ID = eINSTANCE.getTask_Id();

    /**
     * The meta object literal for the '<em><b>Composed of</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference TASK__COMPOSED_OF = eINSTANCE.getTask_Composed_of();

    /**
     * The meta object literal for the '{@link plan.impl.ActionImpl <em>Action</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see plan.impl.ActionImpl
     * @see plan.impl.PlanPackageImpl#getAction()
     * @generated
     */
    EClass ACTION = eINSTANCE.getAction();

    /**
     * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ACTION__ID = eINSTANCE.getAction_Id();

    /**
     * The meta object literal for the '<em><b>Name1</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ACTION__NAME1 = eINSTANCE.getAction_Name1();

    /**
     * The meta object literal for the '{@link plan.impl.SendImpl <em>Send</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see plan.impl.SendImpl
     * @see plan.impl.PlanPackageImpl#getSend()
     * @generated
     */
    EClass SEND = eINSTANCE.getSend();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SEND__NAME = eINSTANCE.getSend_Name();

    /**
     * The meta object literal for the '<em><b>Send</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SEND__SEND = eINSTANCE.getSend_Send();

    /**
     * The meta object literal for the '{@link plan.impl.ReceiveImpl <em>Receive</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see plan.impl.ReceiveImpl
     * @see plan.impl.PlanPackageImpl#getReceive()
     * @generated
     */
    EClass RECEIVE = eINSTANCE.getReceive();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute RECEIVE__NAME = eINSTANCE.getReceive_Name();

    /**
     * The meta object literal for the '<em><b>Receive</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RECEIVE__RECEIVE = eINSTANCE.getReceive_Receive();

    /**
     * The meta object literal for the '{@link plan.impl.MessageImpl <em>Message</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see plan.impl.MessageImpl
     * @see plan.impl.PlanPackageImpl#getMessage()
     * @generated
     */
    EClass MESSAGE = eINSTANCE.getMessage();

    /**
     * The meta object literal for the '<em><b>Name2</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__NAME2 = eINSTANCE.getMessage_Name2();

    /**
     * The meta object literal for the '<em><b>Sender</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__SENDER = eINSTANCE.getMessage_Sender();

    /**
     * The meta object literal for the '<em><b>Receiver</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__RECEIVER = eINSTANCE.getMessage_Receiver();

    /**
     * The meta object literal for the '<em><b>Performative</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__PERFORMATIVE = eINSTANCE.getMessage_Performative();

    /**
     * The meta object literal for the '<em><b>Msg Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__MSG_TYPE = eINSTANCE.getMessage_MsgType();

    /**
     * The meta object literal for the '<em><b>Content</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute MESSAGE__CONTENT = eINSTANCE.getMessage_Content();

  }

} //PlanPackage
