/*
 * 
 */
package role.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

import role.DomainRole;
import role.Interaction;
import role.OntologyMediatorRole;
import role.RegistrationRole;
import role.Role;
import role.RolePackage;
import role.RoleViewpoint;
import role.SemanticWebService;
import role.diagram.edit.parts.DomainRoleEditPart;
import role.diagram.edit.parts.InteractionEditPart;
import role.diagram.edit.parts.OntologyMediatorRoleEditPart;
import role.diagram.edit.parts.RegistrationRoleAdvertisesEditPart;
import role.diagram.edit.parts.RegistrationRoleEditPart;
import role.diagram.edit.parts.RoleRealizesEditPart;
import role.diagram.edit.parts.RoleViewpointEditPart;
import role.diagram.edit.parts.SemanticWebServiceEditPart;
import role.diagram.providers.RoleElementTypes;

/**
 * @generated
 */
public class RoleDiagramUpdater {

	/**
	 * @generated
	 */
	public static boolean isShortcutOrphaned(View view) {
		return !view.isSetElement() || view.getElement() == null
				|| view.getElement().eIsProxy();
	}

	/**
	 * @generated
	 */
	public static List<RoleNodeDescriptor> getSemanticChildren(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case RoleViewpointEditPart.VISUAL_ID:
			return getRoleViewpoint_1000SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleNodeDescriptor> getRoleViewpoint_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		RoleViewpoint modelElement = (RoleViewpoint) view.getElement();
		LinkedList<RoleNodeDescriptor> result = new LinkedList<RoleNodeDescriptor>();
		for (Iterator<?> it = modelElement.getHasRegistrationRole().iterator(); it
				.hasNext();) {
			RegistrationRole childElement = (RegistrationRole) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == RegistrationRoleEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasOntologyMediatorRole()
				.iterator(); it.hasNext();) {
			OntologyMediatorRole childElement = (OntologyMediatorRole) it
					.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OntologyMediatorRoleEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasDomainRole().iterator(); it
				.hasNext();) {
			DomainRole childElement = (DomainRole) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == DomainRoleEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasSemanticWebService()
				.iterator(); it.hasNext();) {
			SemanticWebService childElement = (SemanticWebService) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == SemanticWebServiceEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getHasInteraction().iterator(); it
				.hasNext();) {
			Interaction childElement = (Interaction) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == InteractionEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getContainedLinks(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case RoleViewpointEditPart.VISUAL_ID:
			return getRoleViewpoint_1000ContainedLinks(view);
		case RegistrationRoleEditPart.VISUAL_ID:
			return getRegistrationRole_2001ContainedLinks(view);
		case OntologyMediatorRoleEditPart.VISUAL_ID:
			return getOntologyMediatorRole_2002ContainedLinks(view);
		case DomainRoleEditPart.VISUAL_ID:
			return getDomainRole_2003ContainedLinks(view);
		case SemanticWebServiceEditPart.VISUAL_ID:
			return getSemanticWebService_2004ContainedLinks(view);
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_2005ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getIncomingLinks(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case RegistrationRoleEditPart.VISUAL_ID:
			return getRegistrationRole_2001IncomingLinks(view);
		case OntologyMediatorRoleEditPart.VISUAL_ID:
			return getOntologyMediatorRole_2002IncomingLinks(view);
		case DomainRoleEditPart.VISUAL_ID:
			return getDomainRole_2003IncomingLinks(view);
		case SemanticWebServiceEditPart.VISUAL_ID:
			return getSemanticWebService_2004IncomingLinks(view);
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_2005IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getOutgoingLinks(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case RegistrationRoleEditPart.VISUAL_ID:
			return getRegistrationRole_2001OutgoingLinks(view);
		case OntologyMediatorRoleEditPart.VISUAL_ID:
			return getOntologyMediatorRole_2002OutgoingLinks(view);
		case DomainRoleEditPart.VISUAL_ID:
			return getDomainRole_2003OutgoingLinks(view);
		case SemanticWebServiceEditPart.VISUAL_ID:
			return getSemanticWebService_2004OutgoingLinks(view);
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_2005OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getRoleViewpoint_1000ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getRegistrationRole_2001ContainedLinks(
			View view) {
		RegistrationRole modelElement = (RegistrationRole) view.getElement();
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Role_Realizes_4001(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_RegistrationRole_Advertises_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getOntologyMediatorRole_2002ContainedLinks(
			View view) {
		OntologyMediatorRole modelElement = (OntologyMediatorRole) view
				.getElement();
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Role_Realizes_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getDomainRole_2003ContainedLinks(
			View view) {
		DomainRole modelElement = (DomainRole) view.getElement();
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Role_Realizes_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getSemanticWebService_2004ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getInteraction_2005ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getRegistrationRole_2001IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getOntologyMediatorRole_2002IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getDomainRole_2003IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getSemanticWebService_2004IncomingLinks(
			View view) {
		SemanticWebService modelElement = (SemanticWebService) view
				.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_RegistrationRole_Advertises_4002(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getInteraction_2005IncomingLinks(
			View view) {
		Interaction modelElement = (Interaction) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Role_Realizes_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getRegistrationRole_2001OutgoingLinks(
			View view) {
		RegistrationRole modelElement = (RegistrationRole) view.getElement();
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Role_Realizes_4001(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_RegistrationRole_Advertises_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getOntologyMediatorRole_2002OutgoingLinks(
			View view) {
		OntologyMediatorRole modelElement = (OntologyMediatorRole) view
				.getElement();
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Role_Realizes_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getDomainRole_2003OutgoingLinks(
			View view) {
		DomainRole modelElement = (DomainRole) view.getElement();
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Role_Realizes_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getSemanticWebService_2004OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<RoleLinkDescriptor> getInteraction_2005OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	private static Collection<RoleLinkDescriptor> getIncomingFeatureModelFacetLinks_Role_Realizes_4001(
			Interaction target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == RolePackage.eINSTANCE
					.getRole_Realizes()) {
				result.add(new RoleLinkDescriptor(setting.getEObject(), target,
						RoleElementTypes.RoleRealizes_4001,
						RoleRealizesEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<RoleLinkDescriptor> getIncomingFeatureModelFacetLinks_RegistrationRole_Advertises_4002(
			SemanticWebService target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == RolePackage.eINSTANCE
					.getRegistrationRole_Advertises()) {
				result.add(new RoleLinkDescriptor(setting.getEObject(), target,
						RoleElementTypes.RegistrationRoleAdvertises_4002,
						RegistrationRoleAdvertisesEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<RoleLinkDescriptor> getOutgoingFeatureModelFacetLinks_Role_Realizes_4001(
			Role source) {
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		for (Iterator<?> destinations = source.getRealizes().iterator(); destinations
				.hasNext();) {
			Interaction destination = (Interaction) destinations.next();
			result.add(new RoleLinkDescriptor(source, destination,
					RoleElementTypes.RoleRealizes_4001,
					RoleRealizesEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<RoleLinkDescriptor> getOutgoingFeatureModelFacetLinks_RegistrationRole_Advertises_4002(
			RegistrationRole source) {
		LinkedList<RoleLinkDescriptor> result = new LinkedList<RoleLinkDescriptor>();
		for (Iterator<?> destinations = source.getAdvertises().iterator(); destinations
				.hasNext();) {
			SemanticWebService destination = (SemanticWebService) destinations
					.next();
			result.add(new RoleLinkDescriptor(source, destination,
					RoleElementTypes.RegistrationRoleAdvertises_4002,
					RegistrationRoleAdvertisesEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		 * @generated
		 */
		@Override
		public List<RoleNodeDescriptor> getSemanticChildren(View view) {
			return RoleDiagramUpdater.getSemanticChildren(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<RoleLinkDescriptor> getContainedLinks(View view) {
			return RoleDiagramUpdater.getContainedLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<RoleLinkDescriptor> getIncomingLinks(View view) {
			return RoleDiagramUpdater.getIncomingLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<RoleLinkDescriptor> getOutgoingLinks(View view) {
			return RoleDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
