/*
 * 
 */
package role.diagram.part;

import java.util.Collections;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import role.diagram.providers.RoleElementTypes;

/**
 * @generated
 */
public class RolePaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createObjects1Group());
		paletteRoot.add(createConnections2Group());
	}

	/**
	 * Creates "Objects" palette tool group
	 * @generated
	 */
	private PaletteContainer createObjects1Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Objects1Group_title);
		paletteContainer.setId("createObjects1Group"); //$NON-NLS-1$
		paletteContainer.add(createDomainRole1CreationTool());
		paletteContainer.add(createInteraction2CreationTool());
		paletteContainer.add(createOntologyMediatorRole3CreationTool());
		paletteContainer.add(createRegistrationRole4CreationTool());
		paletteContainer.add(createSemanticWebService5CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Connections" palette tool group
	 * @generated
	 */
	private PaletteContainer createConnections2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Connections2Group_title);
		paletteContainer.setId("createConnections2Group"); //$NON-NLS-1$
		paletteContainer.add(createAdvertises1CreationTool());
		paletteContainer.add(createRealizes2CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createDomainRole1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.DomainRole1CreationTool_title,
				Messages.DomainRole1CreationTool_desc,
				Collections.singletonList(RoleElementTypes.DomainRole_2003));
		entry.setId("createDomainRole1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.DomainRole_2003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createInteraction2CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Interaction2CreationTool_title,
				Messages.Interaction2CreationTool_desc,
				Collections.singletonList(RoleElementTypes.Interaction_2005));
		entry.setId("createInteraction2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.Interaction_2005));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createOntologyMediatorRole3CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.OntologyMediatorRole3CreationTool_title,
				Messages.OntologyMediatorRole3CreationTool_desc,
				Collections
						.singletonList(RoleElementTypes.OntologyMediatorRole_2002));
		entry.setId("createOntologyMediatorRole3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.OntologyMediatorRole_2002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRegistrationRole4CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.RegistrationRole4CreationTool_title,
				Messages.RegistrationRole4CreationTool_desc,
				Collections
						.singletonList(RoleElementTypes.RegistrationRole_2001));
		entry.setId("createRegistrationRole4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.RegistrationRole_2001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSemanticWebService5CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.SemanticWebService5CreationTool_title,
				Messages.SemanticWebService5CreationTool_desc,
				Collections
						.singletonList(RoleElementTypes.SemanticWebService_2004));
		entry.setId("createSemanticWebService5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.SemanticWebService_2004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAdvertises1CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Advertises1CreationTool_title,
				Messages.Advertises1CreationTool_desc,
				Collections
						.singletonList(RoleElementTypes.RegistrationRoleAdvertises_4002));
		entry.setId("createAdvertises1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.RegistrationRoleAdvertises_4002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRealizes2CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Realizes2CreationTool_title,
				Messages.Realizes2CreationTool_desc,
				Collections.singletonList(RoleElementTypes.RoleRealizes_4001));
		entry.setId("createRealizes2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.RoleRealizes_4001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List<IElementType> elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List<IElementType> relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
