/*
 * 
 */
package role.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import role.RolePackage;
import role.diagram.edit.parts.DomainRoleEditPart;
import role.diagram.edit.parts.InteractionEditPart;
import role.diagram.edit.parts.OntologyMediatorRoleEditPart;
import role.diagram.edit.parts.RegistrationRoleAdvertisesEditPart;
import role.diagram.edit.parts.RegistrationRoleEditPart;
import role.diagram.edit.parts.RoleRealizesEditPart;
import role.diagram.edit.parts.RoleViewpointEditPart;
import role.diagram.edit.parts.SemanticWebServiceEditPart;
import role.diagram.part.RoleDiagramEditorPlugin;

/**
 * @generated
 */
public class RoleElementTypes {

	/**
	 * @generated
	 */
	private RoleElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType RoleViewpoint_1000 = getElementType("Role.diagram.RoleViewpoint_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RegistrationRole_2001 = getElementType("Role.diagram.RegistrationRole_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType OntologyMediatorRole_2002 = getElementType("Role.diagram.OntologyMediatorRole_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType DomainRole_2003 = getElementType("Role.diagram.DomainRole_2003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SemanticWebService_2004 = getElementType("Role.diagram.SemanticWebService_2004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Interaction_2005 = getElementType("Role.diagram.Interaction_2005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RoleRealizes_4001 = getElementType("Role.diagram.RoleRealizes_4001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RegistrationRoleAdvertises_4002 = getElementType("Role.diagram.RegistrationRoleAdvertises_4002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return RoleDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(RoleViewpoint_1000,
					RolePackage.eINSTANCE.getRoleViewpoint());

			elements.put(RegistrationRole_2001,
					RolePackage.eINSTANCE.getRegistrationRole());

			elements.put(OntologyMediatorRole_2002,
					RolePackage.eINSTANCE.getOntologyMediatorRole());

			elements.put(DomainRole_2003, RolePackage.eINSTANCE.getDomainRole());

			elements.put(SemanticWebService_2004,
					RolePackage.eINSTANCE.getSemanticWebService());

			elements.put(Interaction_2005,
					RolePackage.eINSTANCE.getInteraction());

			elements.put(RoleRealizes_4001,
					RolePackage.eINSTANCE.getRole_Realizes());

			elements.put(RegistrationRoleAdvertises_4002,
					RolePackage.eINSTANCE.getRegistrationRole_Advertises());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(RoleViewpoint_1000);
			KNOWN_ELEMENT_TYPES.add(RegistrationRole_2001);
			KNOWN_ELEMENT_TYPES.add(OntologyMediatorRole_2002);
			KNOWN_ELEMENT_TYPES.add(DomainRole_2003);
			KNOWN_ELEMENT_TYPES.add(SemanticWebService_2004);
			KNOWN_ELEMENT_TYPES.add(Interaction_2005);
			KNOWN_ELEMENT_TYPES.add(RoleRealizes_4001);
			KNOWN_ELEMENT_TYPES.add(RegistrationRoleAdvertises_4002);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case RoleViewpointEditPart.VISUAL_ID:
			return RoleViewpoint_1000;
		case RegistrationRoleEditPart.VISUAL_ID:
			return RegistrationRole_2001;
		case OntologyMediatorRoleEditPart.VISUAL_ID:
			return OntologyMediatorRole_2002;
		case DomainRoleEditPart.VISUAL_ID:
			return DomainRole_2003;
		case SemanticWebServiceEditPart.VISUAL_ID:
			return SemanticWebService_2004;
		case InteractionEditPart.VISUAL_ID:
			return Interaction_2005;
		case RoleRealizesEditPart.VISUAL_ID:
			return RoleRealizes_4001;
		case RegistrationRoleAdvertisesEditPart.VISUAL_ID:
			return RegistrationRoleAdvertises_4002;
		}
		return null;
	}

}
