/**
 */
package role.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import role.ArchitectureRole;
import role.DomainRole;
import role.Interaction;
import role.OntologyMediatorRole;
import role.RegistrationRole;
import role.Role;
import role.RoleFactory;
import role.RolePackage;
import role.RoleViewpoint;
import role.SemanticWebService;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RolePackageImpl extends EPackageImpl implements RolePackage
{
  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass roleViewpointEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass roleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass domainRoleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass architectureRoleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass registrationRoleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass ontologyMediatorRoleEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass semanticWebServiceEClass = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private EClass interactionEClass = null;

  /**
   * Creates an instance of the model <b>Package</b>, registered with
   * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
   * package URI value.
   * <p>Note: the correct way to create the package is via the static
   * factory method {@link #init init()}, which also performs
   * initialization of the package, or returns the registered package,
   * if one already exists.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.emf.ecore.EPackage.Registry
   * @see role.RolePackage#eNS_URI
   * @see #init()
   * @generated
   */
  private RolePackageImpl()
  {
    super(eNS_URI, RoleFactory.eINSTANCE);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static boolean isInited = false;

  /**
   * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
   * 
   * <p>This method is used to initialize {@link RolePackage#eINSTANCE} when that field is accessed.
   * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #eNS_URI
   * @see #createPackageContents()
   * @see #initializePackageContents()
   * @generated
   */
  public static RolePackage init()
  {
    if (isInited) return (RolePackage)EPackage.Registry.INSTANCE.getEPackage(RolePackage.eNS_URI);

    // Obtain or create and register package
    RolePackageImpl theRolePackage = (RolePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof RolePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new RolePackageImpl());

    isInited = true;

    // Create package meta-data objects
    theRolePackage.createPackageContents();

    // Initialize created meta-data
    theRolePackage.initializePackageContents();

    // Mark meta-data to indicate it can't be changed
    theRolePackage.freeze();

  
    // Update the registry and return the package
    EPackage.Registry.INSTANCE.put(RolePackage.eNS_URI, theRolePackage);
    return theRolePackage;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getRoleViewpoint()
  {
    return roleViewpointEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRoleViewpoint_HasDomainRole()
  {
    return (EReference)roleViewpointEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRoleViewpoint_HasRegistrationRole()
  {
    return (EReference)roleViewpointEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRoleViewpoint_HasOntologyMediatorRole()
  {
    return (EReference)roleViewpointEClass.getEStructuralFeatures().get(2);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRoleViewpoint_HasSemanticWebService()
  {
    return (EReference)roleViewpointEClass.getEStructuralFeatures().get(3);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRoleViewpoint_HasInteraction()
  {
    return (EReference)roleViewpointEClass.getEStructuralFeatures().get(4);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getRole()
  {
    return roleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getRole_Name()
  {
    return (EAttribute)roleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRole_Realizes()
  {
    return (EReference)roleEClass.getEStructuralFeatures().get(1);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getDomainRole()
  {
    return domainRoleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getArchitectureRole()
  {
    return architectureRoleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getArchitectureRole_Scope()
  {
    return (EAttribute)architectureRoleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getRegistrationRole()
  {
    return registrationRoleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EReference getRegistrationRole_Advertises()
  {
    return (EReference)registrationRoleEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getOntologyMediatorRole()
  {
    return ontologyMediatorRoleEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getSemanticWebService()
  {
    return semanticWebServiceEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getSemanticWebService_Name()
  {
    return (EAttribute)semanticWebServiceEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getInteraction()
  {
    return interactionEClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EAttribute getInteraction_Name()
  {
    return (EAttribute)interactionEClass.getEStructuralFeatures().get(0);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RoleFactory getRoleFactory()
  {
    return (RoleFactory)getEFactoryInstance();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isCreated = false;

  /**
   * Creates the meta-model objects for the package.  This method is
   * guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void createPackageContents()
  {
    if (isCreated) return;
    isCreated = true;

    // Create classes and their features
    roleViewpointEClass = createEClass(ROLE_VIEWPOINT);
    createEReference(roleViewpointEClass, ROLE_VIEWPOINT__HAS_DOMAIN_ROLE);
    createEReference(roleViewpointEClass, ROLE_VIEWPOINT__HAS_REGISTRATION_ROLE);
    createEReference(roleViewpointEClass, ROLE_VIEWPOINT__HAS_ONTOLOGY_MEDIATOR_ROLE);
    createEReference(roleViewpointEClass, ROLE_VIEWPOINT__HAS_SEMANTIC_WEB_SERVICE);
    createEReference(roleViewpointEClass, ROLE_VIEWPOINT__HAS_INTERACTION);

    roleEClass = createEClass(ROLE);
    createEAttribute(roleEClass, ROLE__NAME);
    createEReference(roleEClass, ROLE__REALIZES);

    domainRoleEClass = createEClass(DOMAIN_ROLE);

    architectureRoleEClass = createEClass(ARCHITECTURE_ROLE);
    createEAttribute(architectureRoleEClass, ARCHITECTURE_ROLE__SCOPE);

    registrationRoleEClass = createEClass(REGISTRATION_ROLE);
    createEReference(registrationRoleEClass, REGISTRATION_ROLE__ADVERTISES);

    ontologyMediatorRoleEClass = createEClass(ONTOLOGY_MEDIATOR_ROLE);

    semanticWebServiceEClass = createEClass(SEMANTIC_WEB_SERVICE);
    createEAttribute(semanticWebServiceEClass, SEMANTIC_WEB_SERVICE__NAME);

    interactionEClass = createEClass(INTERACTION);
    createEAttribute(interactionEClass, INTERACTION__NAME);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private boolean isInitialized = false;

  /**
   * Complete the initialization of the package and its meta-model.  This
   * method is guarded to have no affect on any invocation but its first.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void initializePackageContents()
  {
    if (isInitialized) return;
    isInitialized = true;

    // Initialize package
    setName(eNAME);
    setNsPrefix(eNS_PREFIX);
    setNsURI(eNS_URI);

    // Create type parameters

    // Set bounds for type parameters

    // Add supertypes to classes
    domainRoleEClass.getESuperTypes().add(this.getRole());
    architectureRoleEClass.getESuperTypes().add(this.getRole());
    registrationRoleEClass.getESuperTypes().add(this.getArchitectureRole());
    ontologyMediatorRoleEClass.getESuperTypes().add(this.getArchitectureRole());

    // Initialize classes and features; add operations and parameters
    initEClass(roleViewpointEClass, RoleViewpoint.class, "RoleViewpoint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getRoleViewpoint_HasDomainRole(), this.getDomainRole(), null, "hasDomainRole", null, 0, -1, RoleViewpoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getRoleViewpoint_HasRegistrationRole(), this.getRegistrationRole(), null, "hasRegistrationRole", null, 0, -1, RoleViewpoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getRoleViewpoint_HasOntologyMediatorRole(), this.getOntologyMediatorRole(), null, "hasOntologyMediatorRole", null, 0, -1, RoleViewpoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getRoleViewpoint_HasSemanticWebService(), this.getSemanticWebService(), null, "hasSemanticWebService", null, 0, -1, RoleViewpoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getRoleViewpoint_HasInteraction(), this.getInteraction(), null, "hasInteraction", null, 0, -1, RoleViewpoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(roleEClass, Role.class, "Role", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getRole_Name(), ecorePackage.getEString(), "name", null, 0, 1, Role.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
    initEReference(getRole_Realizes(), this.getInteraction(), null, "realizes", null, 1, -1, Role.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(domainRoleEClass, DomainRole.class, "DomainRole", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    initEClass(architectureRoleEClass, ArchitectureRole.class, "ArchitectureRole", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getArchitectureRole_Scope(), ecorePackage.getEString(), "scope", null, 0, 1, ArchitectureRole.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(registrationRoleEClass, RegistrationRole.class, "RegistrationRole", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEReference(getRegistrationRole_Advertises(), this.getSemanticWebService(), null, "advertises", null, 1, -1, RegistrationRole.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(ontologyMediatorRoleEClass, OntologyMediatorRole.class, "OntologyMediatorRole", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

    initEClass(semanticWebServiceEClass, SemanticWebService.class, "SemanticWebService", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getSemanticWebService_Name(), ecorePackage.getEString(), "name", null, 0, 1, SemanticWebService.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    initEClass(interactionEClass, Interaction.class, "Interaction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
    initEAttribute(getInteraction_Name(), ecorePackage.getEString(), "name", null, 0, 1, Interaction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

    // Create resource
    createResource(eNS_URI);

    // Create annotations
    // gmf.diagram
    createGmfAnnotations();
    // gmf.link
    createGmf_1Annotations();
    // gmf.node
    createGmf_2Annotations();
  }

  /**
   * Initializes the annotations for <b>gmf.diagram</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createGmfAnnotations()
  {
    String source = "gmf.diagram";		
    addAnnotation
      (roleViewpointEClass, 
       source, 
       new String[] 
       {
       });							
  }

  /**
   * Initializes the annotations for <b>gmf.link</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createGmf_1Annotations()
  {
    String source = "gmf.link";			
    addAnnotation
      (getRole_Realizes(), 
       source, 
       new String[] 
       {
       "label", "realizes",
       "target.decoration", "arrow"
       });				
    addAnnotation
      (getRegistrationRole_Advertises(), 
       source, 
       new String[] 
       {
       "label", "advertises",
       "target.decoration", "arrow"
       });			
  }

  /**
   * Initializes the annotations for <b>gmf.node</b>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void createGmf_2Annotations()
  {
    String source = "gmf.node";				
    addAnnotation
      (domainRoleEClass, 
       source, 
       new String[] 
       {
       "label", "name"
       });		
    addAnnotation
      (registrationRoleEClass, 
       source, 
       new String[] 
       {
       "label", "name"
       });			
    addAnnotation
      (ontologyMediatorRoleEClass, 
       source, 
       new String[] 
       {
       "label", "name"
       });		
    addAnnotation
      (semanticWebServiceEClass, 
       source, 
       new String[] 
       {
       "label", "name"
       });		
    addAnnotation
      (interactionEClass, 
       source, 
       new String[] 
       {
       "label", "name"
       });
  }

} //RolePackageImpl
