/**
 */
package role.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import role.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see role.RolePackage
 * @generated
 */
public class RoleAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static RolePackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RoleAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = RolePackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RoleSwitch<Adapter> modelSwitch =
    new RoleSwitch<Adapter>()
    {
      @Override
      public Adapter caseRoleViewpoint(RoleViewpoint object)
      {
        return createRoleViewpointAdapter();
      }
      @Override
      public Adapter caseRole(Role object)
      {
        return createRoleAdapter();
      }
      @Override
      public Adapter caseDomainRole(DomainRole object)
      {
        return createDomainRoleAdapter();
      }
      @Override
      public Adapter caseArchitectureRole(ArchitectureRole object)
      {
        return createArchitectureRoleAdapter();
      }
      @Override
      public Adapter caseRegistrationRole(RegistrationRole object)
      {
        return createRegistrationRoleAdapter();
      }
      @Override
      public Adapter caseOntologyMediatorRole(OntologyMediatorRole object)
      {
        return createOntologyMediatorRoleAdapter();
      }
      @Override
      public Adapter caseSemanticWebService(SemanticWebService object)
      {
        return createSemanticWebServiceAdapter();
      }
      @Override
      public Adapter caseInteraction(Interaction object)
      {
        return createInteractionAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link role.RoleViewpoint <em>Viewpoint</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see role.RoleViewpoint
   * @generated
   */
  public Adapter createRoleViewpointAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link role.Role <em>Role</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see role.Role
   * @generated
   */
  public Adapter createRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link role.DomainRole <em>Domain Role</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see role.DomainRole
   * @generated
   */
  public Adapter createDomainRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link role.ArchitectureRole <em>Architecture Role</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see role.ArchitectureRole
   * @generated
   */
  public Adapter createArchitectureRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link role.RegistrationRole <em>Registration Role</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see role.RegistrationRole
   * @generated
   */
  public Adapter createRegistrationRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link role.OntologyMediatorRole <em>Ontology Mediator Role</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see role.OntologyMediatorRole
   * @generated
   */
  public Adapter createOntologyMediatorRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link role.SemanticWebService <em>Semantic Web Service</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see role.SemanticWebService
   * @generated
   */
  public Adapter createSemanticWebServiceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link role.Interaction <em>Interaction</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see role.Interaction
   * @generated
   */
  public Adapter createInteractionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //RoleAdapterFactory
