package SWSInteraction.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class SSMatchmakerAgentPlaysRegRoleReorientCommand extends
		EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public SSMatchmakerAgentPlaysRegRoleReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == referenceOwner instanceof SWSInteraction.SSMatchmakerAgent) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof SWSInteraction.Role && newEnd instanceof SWSInteraction.SSMatchmakerAgent)) {
			return false;
		}
		return SWSInteraction.diagram.edit.policies.SWSInteractionBaseItemSemanticEditPolicy
				.getLinkConstraints()
				.canExistSSMatchmakerAgentPlaysRegRole_4032(getNewSource(),
						getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof SWSInteraction.Role && newEnd instanceof SWSInteraction.Role)) {
			return false;
		}
		return SWSInteraction.diagram.edit.policies.SWSInteractionBaseItemSemanticEditPolicy
				.getLinkConstraints()
				.canExistSSMatchmakerAgentPlaysRegRole_4032(getOldSource(),
						getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().setPlaysRegRole(null);
		getNewSource().setPlaysRegRole(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().setPlaysRegRole(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected SWSInteraction.SSMatchmakerAgent getOldSource() {
		return (SWSInteraction.SSMatchmakerAgent) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected SWSInteraction.SSMatchmakerAgent getNewSource() {
		return (SWSInteraction.SSMatchmakerAgent) newEnd;
	}

	/**
	 * @generated
	 */
	protected SWSInteraction.Role getOldTarget() {
		return (SWSInteraction.Role) oldEnd;
	}

	/**
	 * @generated
	 */
	protected SWSInteraction.Role getNewTarget() {
		return (SWSInteraction.Role) newEnd;
	}
}
