package SWSInteraction.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class SS_RegisterPlanAdvertisesReorientCommand extends
		EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public SS_RegisterPlanAdvertisesReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == referenceOwner instanceof SWSInteraction.SS_RegisterPlan) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof SWSInteraction.Interface && newEnd instanceof SWSInteraction.SS_RegisterPlan)) {
			return false;
		}
		return SWSInteraction.diagram.edit.policies.SWSInteractionBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistSS_RegisterPlanAdvertises_4009(
						getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof SWSInteraction.Interface && newEnd instanceof SWSInteraction.Interface)) {
			return false;
		}
		return SWSInteraction.diagram.edit.policies.SWSInteractionBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistSS_RegisterPlanAdvertises_4009(
						getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getAdvertises().remove(getOldTarget());
		getNewSource().getAdvertises().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getAdvertises().remove(getOldTarget());
		getOldSource().getAdvertises().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected SWSInteraction.SS_RegisterPlan getOldSource() {
		return (SWSInteraction.SS_RegisterPlan) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected SWSInteraction.SS_RegisterPlan getNewSource() {
		return (SWSInteraction.SS_RegisterPlan) newEnd;
	}

	/**
	 * @generated
	 */
	protected SWSInteraction.Interface getOldTarget() {
		return (SWSInteraction.Interface) oldEnd;
	}

	/**
	 * @generated
	 */
	protected SWSInteraction.Interface getNewTarget() {
		return (SWSInteraction.Interface) newEnd;
	}
}
