package SWSInteraction.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.FlowLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LabeledContainer;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.core.edithelpers.CreateElementRequestAdapter;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CreationEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.FlowLayoutEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.requests.CreateViewAndElementRequest;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class SWSEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2004;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public SWSEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicy());
		super.createDefaultEditPolicies();
		installEditPolicy(
				EditPolicyRoles.SEMANTIC_ROLE,
				new SWSInteraction.diagram.edit.policies.SWSItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {

		FlowLayoutEditPolicy lep = new FlowLayoutEditPolicy() {

			protected Command createAddCommand(EditPart child, EditPart after) {
				return null;
			}

			protected Command createMoveChildCommand(EditPart child,
					EditPart after) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new SWSFigure();
	}

	/**
	 * @generated
	 */
	public SWSFigure getPrimaryShape() {
		return (SWSFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.SWSNameEditPart) {
			((SWSInteraction.diagram.edit.parts.SWSNameEditPart) childEditPart)
					.setLabel(getPrimaryShape().getFigureSWSNameFigure());
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSWSServiceCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.SWSNameEditPart) {
			return true;
		}
		if (childEditPart instanceof SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart) {
			IFigure pane = getPrimaryShape()
					.getFigureSWSServiceCompartmentNameFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.remove(((SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart) childEditPart)
					.getFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		if (editPart instanceof SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart) {
			return getPrimaryShape().getFigureSWSServiceCompartmentNameFigure();
		}
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
				.getType(SWSInteraction.diagram.edit.parts.SWSNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(4);
		types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.InterfacePresents_4027);
		types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.ProcessDescribed_by_4028);
		types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.GroundingSupports_4030);
		types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.RoleInteracts_with_4033);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == SWSInteraction.diagram.providers.SWSInteractionElementTypes.InterfacePresents_4027) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.Interface_2005);
		} else if (relationshipType == SWSInteraction.diagram.providers.SWSInteractionElementTypes.ProcessDescribed_by_4028) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.Process_2010);
		} else if (relationshipType == SWSInteraction.diagram.providers.SWSInteractionElementTypes.GroundingSupports_4030) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.Grounding_2008);
		} else if (relationshipType == SWSInteraction.diagram.providers.SWSInteractionElementTypes.RoleInteracts_with_4033) {
			types.add(SWSInteraction.diagram.providers.SWSInteractionElementTypes.Role_2001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public EditPart getTargetEditPart(Request request) {
		if (request instanceof CreateViewAndElementRequest) {
			CreateElementRequestAdapter adapter = ((CreateViewAndElementRequest) request)
					.getViewAndElementDescriptor()
					.getCreateElementRequestAdapter();
			IElementType type = (IElementType) adapter
					.getAdapter(IElementType.class);
			if (type == SWSInteraction.diagram.providers.SWSInteractionElementTypes.WebService_3011) {
				return getChildBySemanticHint(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
						.getType(SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart.VISUAL_ID));
			}
		}
		return super.getTargetEditPart(request);
	}

	/**
	 * @generated
	 */
	public class SWSFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureSWSNameFigure;
		/**
		 * @generated
		 */
		private LabeledContainer fFigureSWSServiceCompartmentNameFigure;

		/**
		 * @generated
		 */
		public SWSFigure() {

			FlowLayout layoutThis = new FlowLayout();
			layoutThis.setStretchMinorAxis(false);
			layoutThis.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutThis.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutThis.setMajorSpacing(5);
			layoutThis.setMinorSpacing(5);
			layoutThis.setHorizontal(true);

			this.setLayoutManager(layoutThis);

			this.setFill(false);
			this.setOutline(false);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureSWSNameFigure = new WrappingLabel();
			fFigureSWSNameFigure.setText("<...>");
			fFigureSWSNameFigure.setForegroundColor(FFIGURESWSNAMEFIGURE_FORE);

			this.add(fFigureSWSNameFigure);

			fFigureSWSServiceCompartmentNameFigure = new LabeledContainer();

			fFigureSWSServiceCompartmentNameFigure
					.setBackgroundColor(FFIGURESWSSERVICECOMPARTMENTNAMEFIGURE_BACK);
			fFigureSWSServiceCompartmentNameFigure.setBorder(new MarginBorder(
					getMapMode().DPtoLP(5), getMapMode().DPtoLP(4),
					getMapMode().DPtoLP(5), getMapMode().DPtoLP(4)));

			this.add(fFigureSWSServiceCompartmentNameFigure);

			FlowLayout layoutFFigureSWSServiceCompartmentNameFigure = new FlowLayout();
			layoutFFigureSWSServiceCompartmentNameFigure
					.setStretchMinorAxis(false);
			layoutFFigureSWSServiceCompartmentNameFigure
					.setMinorAlignment(FlowLayout.ALIGN_LEFTTOP);

			layoutFFigureSWSServiceCompartmentNameFigure
					.setMajorAlignment(FlowLayout.ALIGN_LEFTTOP);
			layoutFFigureSWSServiceCompartmentNameFigure.setMajorSpacing(5);
			layoutFFigureSWSServiceCompartmentNameFigure.setMinorSpacing(5);
			layoutFFigureSWSServiceCompartmentNameFigure.setHorizontal(true);

			fFigureSWSServiceCompartmentNameFigure
					.setLayoutManager(layoutFFigureSWSServiceCompartmentNameFigure);

			WrappingLabel sWSWebServiceCompartmentName1 = new WrappingLabel();
			sWSWebServiceCompartmentName1.setText("<WebServices>");
			sWSWebServiceCompartmentName1
					.setForegroundColor(SWSWEBSERVICECOMPARTMENTNAME1_FORE);

			fFigureSWSServiceCompartmentNameFigure
					.add(sWSWebServiceCompartmentName1);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureSWSNameFigure() {
			return fFigureSWSNameFigure;
		}

		/**
		 * @generated
		 */
		public LabeledContainer getFigureSWSServiceCompartmentNameFigure() {
			return fFigureSWSServiceCompartmentNameFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color FFIGURESWSNAMEFIGURE_FORE = new Color(null, 0, 0, 0);

	/**
	 * @generated
	 */
	static final Color FFIGURESWSSERVICECOMPARTMENTNAMEFIGURE_BACK = new Color(
			null, 180, 180, 180);

	/**
	 * @generated
	 */
	static final Color SWSWEBSERVICECOMPARTMENTNAME1_FORE = new Color(null, 0,
			0, 0);

}
