package SWSInteraction.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.common.core.command.ICompositeCommand;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyReferenceCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyReferenceRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class ProcessItemSemanticEditPolicy
		extends
		SWSInteraction.diagram.edit.policies.SWSInteractionBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public ProcessItemSemanticEditPolicy() {
		super(
				SWSInteraction.diagram.providers.SWSInteractionElementTypes.Process_2010);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		View view = (View) getHost().getModel();
		CompositeTransactionalCommand cmd = new CompositeTransactionalCommand(
				getEditingDomain(), null);
		cmd.setTransactionNestingEnabled(false);
		for (Iterator<?> it = view.getTargetEdges().iterator(); it.hasNext();) {
			Edge incomingLink = (Edge) it.next();
			if (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
					.getVisualID(incomingLink) == SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(
						incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
		}
		for (Iterator<?> it = view.getSourceEdges().iterator(); it.hasNext();) {
			Edge outgoingLink = (Edge) it.next();
			if (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
					.getVisualID(outgoingLink) == SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(
						outgoingLink.getSource().getElement(), null,
						outgoingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
		}
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation == null) {
			// there are indirectly referenced children, need extra commands: false
			addDestroyChildNodesCommand(cmd);
			addDestroyShortcutsCommand(cmd, view);
			// delete host element
			cmd.add(new DestroyElementCommand(req));
		} else {
			cmd.add(new DeleteCommand(getEditingDomain(), view));
		}
		return getGEFWrapper(cmd.reduce());
	}

	/**
	 * @generated
	 */
	private void addDestroyChildNodesCommand(ICompositeCommand cmd) {
		View view = (View) getHost().getModel();
		for (Iterator<?> nit = view.getChildren().iterator(); nit.hasNext();) {
			Node node = (Node) nit.next();
			switch (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
					.getVisualID(node)) {
			case SWSInteraction.diagram.edit.parts.ProcessProcessInputCompartmentEditPart.VISUAL_ID:
				for (Iterator<?> cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getVisualID(cnode)) {
					case SWSInteraction.diagram.edit.parts.Input2EditPart.VISUAL_ID:
						cmd.add(new DestroyElementCommand(
								new DestroyElementRequest(getEditingDomain(),
										cnode.getElement(), false))); // directlyOwned: true
						// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
						// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
						break;
					}
				}
				break;
			case SWSInteraction.diagram.edit.parts.ProcessProcessOutputCompartmentEditPart.VISUAL_ID:
				for (Iterator<?> cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getVisualID(cnode)) {
					case SWSInteraction.diagram.edit.parts.Output2EditPart.VISUAL_ID:
						cmd.add(new DestroyElementCommand(
								new DestroyElementRequest(getEditingDomain(),
										cnode.getElement(), false))); // directlyOwned: true
						// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
						// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
						break;
					}
				}
				break;
			case SWSInteraction.diagram.edit.parts.ProcessProcessPreconditionCompartmentEditPart.VISUAL_ID:
				for (Iterator<?> cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getVisualID(cnode)) {
					case SWSInteraction.diagram.edit.parts.Precondition2EditPart.VISUAL_ID:
						cmd.add(new DestroyElementCommand(
								new DestroyElementRequest(getEditingDomain(),
										cnode.getElement(), false))); // directlyOwned: true
						// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
						// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
						break;
					}
				}
				break;
			case SWSInteraction.diagram.edit.parts.ProcessProcessEffectCompartmentEditPart.VISUAL_ID:
				for (Iterator<?> cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getVisualID(cnode)) {
					case SWSInteraction.diagram.edit.parts.Effect2EditPart.VISUAL_ID:
						cmd.add(new DestroyElementCommand(
								new DestroyElementRequest(getEditingDomain(),
										cnode.getElement(), false))); // directlyOwned: true
						// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
						// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
						break;
					}
				}
				break;
			}
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_ExecutorPlanExecutes_4026 == req
				.getElementType()) {
			return null;
		}
		if (SWSInteraction.diagram.providers.SWSInteractionElementTypes.ProcessDescribed_by_4028 == req
				.getElementType()) {
			return getGEFWrapper(new SWSInteraction.diagram.edit.commands.ProcessDescribed_byCreateCommand(
					req, req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SWSInteraction.diagram.providers.SWSInteractionElementTypes.SS_ExecutorPlanExecutes_4026 == req
				.getElementType()) {
			return getGEFWrapper(new SWSInteraction.diagram.edit.commands.SS_ExecutorPlanExecutesCreateCommand(
					req, req.getSource(), req.getTarget()));
		}
		if (SWSInteraction.diagram.providers.SWSInteractionElementTypes.ProcessDescribed_by_4028 == req
				.getElementType()) {
			return null;
		}
		return null;
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(
			ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID:
			return getGEFWrapper(new SWSInteraction.diagram.edit.commands.SS_ExecutorPlanExecutesReorientCommand(
					req));
		case SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID:
			return getGEFWrapper(new SWSInteraction.diagram.edit.commands.ProcessDescribed_byReorientCommand(
					req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
