package SWSInteraction.diagram.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

/**
 * @generated
 */
public class SWSInteractionNavigatorContentProvider implements
		ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	@SuppressWarnings({ "unchecked", "serial", "rawtypes" })
	public SWSInteractionNavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		myViewer = null;
		unloadAllResources();
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	void unloadAllResources() {
		for (Resource nextResource : myEditingDomain.getResourceSet()
				.getResources()) {
			nextResource.unload();
		}
	}

	/**
	 * @generated
	 */
	void asyncRefresh() {
		if (myViewer != null && !myViewer.getControl().isDisposed()) {
			myViewer.getControl().getDisplay()
					.asyncExec(myViewerRefreshRunnable);
		}
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			ArrayList<SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem> result = new ArrayList<SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem>();
			ArrayList<View> topViews = new ArrayList<View>(resource
					.getContents().size());
			for (EObject o : resource.getContents()) {
				if (o instanceof View) {
					topViews.add((View) o);
				}
			}
			result.addAll(createNavigatorItems(
					selectViewsByType(
							topViews,
							SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.MODEL_ID),
					file, false));
			return result.toArray();
		}

		if (parentElement instanceof SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup) {
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup group = (SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem) {
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem navigatorItem = (SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
				.getVisualID(view)) {

		case SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SemanticWebAgent_2021_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_RegisterPlanAdvertisesEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_RegisterPlanAdvertises_4009_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_RegisterPlanAdvertises_4009_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SWS_2004_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SWSSWSWebServiceCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.WebServiceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfacePresentsEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingSupportsEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.RoleInteracts_withEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_Process_2010_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_Process_2010_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessProcessInputCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.Input2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessProcessOutputCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.Output2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessProcessPreconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.Precondition2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessProcessEffectCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.Effect2EditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_AgreementPlanNegotiatesEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_AgreementPlanNegotiates_4014_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_AgreementPlanNegotiates_4014_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SSMatchmakerAgent_2018_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SSMatchmakerAgent_2018_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanInteracts_withEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentAppliesSS_RegPlanEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentPlaysRegRoleEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_Role_2001_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_Role_2001_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentPlaysRegRoleEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.RoleInteracts_withEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.GroundingSupportsEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_GroundingSupports_4030_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_GroundingSupports_4030_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.RoleInteracts_withEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_RoleInteracts_with_4033_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_RoleInteracts_with_4033_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_AgreementPlan_2015_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_AgreementPlan_2015_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_AgreementPlanNegotiatesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SemanticWebAgentPlays_4010_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SemanticWebAgentPlays_4010_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_Grounding_2008_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_Grounding_2008_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanUsesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingCallsEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingSupportsEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_RegisterPlan_2016_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_RegisterPlan_2016_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_RegisterPlanAdvertisesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentAppliesSS_RegPlanEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_ExecutorPlanExecutes_4026_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_ExecutorPlanExecutes_4026_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentAppliesSS_RegPlanEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SSMatchmakerAgentAppliesSS_RegPlan_4031_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SSMatchmakerAgentAppliesSS_RegPlan_4031_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_FinderPlanInteracts_withEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_FinderPlanInteracts_with_4012_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_FinderPlanInteracts_with_4012_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_FinderPlan_2014_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_FinderPlan_2014_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanInteracts_withEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanDiscoversEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_ExecutorPlan_2017_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_ExecutorPlan_2017_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanUsesEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_ExecutorPlanUsesEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_ExecutorPlanUses_4016_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_ExecutorPlanUses_4016_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SemanticWebAgentApplies_4008_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SemanticWebAgentApplies_4008_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SS_FinderPlanDiscoversEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_FinderPlanDiscovers_4013_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SS_FinderPlanDiscovers_4013_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Diagram sv = (Diagram) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup links = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SWSInteractionViewpoint_1000_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_AgreementPlanEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_RegisterPlanEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_RegisterPlanAdvertisesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentAppliesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SemanticWebAgentPlaysEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanInteracts_withEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanDiscoversEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_AgreementPlanNegotiatesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanExecutesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_ExecutorPlanUsesEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfacePresentsEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingCallsEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingSupportsEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentAppliesSS_RegPlanEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentPlaysRegRoleEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.RoleInteracts_withEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.WebServiceEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_WebService_3011_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingCallsEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.SSMatchmakerAgentPlaysRegRoleEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SSMatchmakerAgentPlaysRegRole_4032_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_SSMatchmakerAgentPlaysRegRole_4032_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.RoleEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SSMatchmakerAgentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.InterfacePresentsEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_InterfacePresents_4027_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_InterfacePresents_4027_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.GroundingCallsEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_GroundingCalls_4019_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_GroundingCalls_4019_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.WebServiceEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.GroundingEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.ProcessDescribed_byEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup target = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_ProcessDescribed_by_4028_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup source = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_ProcessDescribed_by_4028_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SWSEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.ProcessEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case SWSInteraction.diagram.edit.parts.InterfaceEditPart.VISUAL_ID: {
			LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem> result = new LinkedList<SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem>();
			Node sv = (Node) view;
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup incominglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_Interface_2005_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup outgoinglinks = new SWSInteraction.diagram.navigator.SWSInteractionNavigatorGroup(
					SWSInteraction.diagram.part.Messages.NavigatorGroupName_Interface_2005_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceInterfaceInputCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InputEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceInterfaceOutputCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.OutputEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceInterfacePreconditionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.PreconditionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfaceInterfaceEffectCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.EffectEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_RegisterPlanAdvertisesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_FinderPlanDiscoversEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.SS_AgreementPlanNegotiatesEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
							.getType(SWSInteraction.diagram.edit.parts.InterfacePresentsEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksSourceByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksTargetByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getOutgoingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getIncomingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getChildrenByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getDiagramLinksByType(
			Collection<Diagram> diagrams, String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (Diagram nextDiagram : diagrams) {
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	// TODO refactor as static method
	/**
	 * @generated
	 */
	private Collection<View> selectViewsByType(Collection<View> views,
			String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (View nextView : views) {
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return SWSInteraction.diagram.edit.parts.SWSInteractionViewpointEditPart.MODEL_ID
				.equals(SWSInteraction.diagram.part.SWSInteractionVisualIDRegistry
						.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection<SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem> createNavigatorItems(
			Collection<View> views, Object parent, boolean isLeafs) {
		ArrayList<SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem> result = new ArrayList<SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem>(
				views.size());
		for (View nextView : views) {
			result.add(new SWSInteraction.diagram.navigator.SWSInteractionNavigatorItem(
					nextView, parent, isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem) {
			SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem abstractNavigatorItem = (SWSInteraction.diagram.navigator.SWSInteractionAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
