/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SWSInteraction.provider;

import SWSInteraction.util.SWSInteractionAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SWSInteractionItemProviderAdapterFactory extends SWSInteractionAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SWSInteractionItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Plan} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PlanItemProvider planItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Plan}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPlanAdapter() {
		if (planItemProvider == null) {
			planItemProvider = new PlanItemProvider(this);
		}

		return planItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.SemanticWebAgent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SemanticWebAgentItemProvider semanticWebAgentItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.SemanticWebAgent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSemanticWebAgentAdapter() {
		if (semanticWebAgentItemProvider == null) {
			semanticWebAgentItemProvider = new SemanticWebAgentItemProvider(this);
		}

		return semanticWebAgentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Role} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RoleItemProvider roleItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Role}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRoleAdapter() {
		if (roleItemProvider == null) {
			roleItemProvider = new RoleItemProvider(this);
		}

		return roleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.SSMatchmakerAgent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SSMatchmakerAgentItemProvider ssMatchmakerAgentItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.SSMatchmakerAgent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSSMatchmakerAgentAdapter() {
		if (ssMatchmakerAgentItemProvider == null) {
			ssMatchmakerAgentItemProvider = new SSMatchmakerAgentItemProvider(this);
		}

		return ssMatchmakerAgentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.SS_RegisterPlan} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SS_RegisterPlanItemProvider sS_RegisterPlanItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.SS_RegisterPlan}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSS_RegisterPlanAdapter() {
		if (sS_RegisterPlanItemProvider == null) {
			sS_RegisterPlanItemProvider = new SS_RegisterPlanItemProvider(this);
		}

		return sS_RegisterPlanItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.SS_FinderPlan} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SS_FinderPlanItemProvider sS_FinderPlanItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.SS_FinderPlan}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSS_FinderPlanAdapter() {
		if (sS_FinderPlanItemProvider == null) {
			sS_FinderPlanItemProvider = new SS_FinderPlanItemProvider(this);
		}

		return sS_FinderPlanItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.SS_AgreementPlan} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SS_AgreementPlanItemProvider sS_AgreementPlanItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.SS_AgreementPlan}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSS_AgreementPlanAdapter() {
		if (sS_AgreementPlanItemProvider == null) {
			sS_AgreementPlanItemProvider = new SS_AgreementPlanItemProvider(this);
		}

		return sS_AgreementPlanItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.SS_ExecutorPlan} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SS_ExecutorPlanItemProvider sS_ExecutorPlanItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.SS_ExecutorPlan}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSS_ExecutorPlanAdapter() {
		if (sS_ExecutorPlanItemProvider == null) {
			sS_ExecutorPlanItemProvider = new SS_ExecutorPlanItemProvider(this);
		}

		return sS_ExecutorPlanItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.SWS} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SWSItemProvider swsItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.SWS}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSWSAdapter() {
		if (swsItemProvider == null) {
			swsItemProvider = new SWSItemProvider(this);
		}

		return swsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Interface} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InterfaceItemProvider interfaceItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Interface}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInterfaceAdapter() {
		if (interfaceItemProvider == null) {
			interfaceItemProvider = new InterfaceItemProvider(this);
		}

		return interfaceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Process} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProcessItemProvider processItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Process}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProcessAdapter() {
		if (processItemProvider == null) {
			processItemProvider = new ProcessItemProvider(this);
		}

		return processItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Grounding} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GroundingItemProvider groundingItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Grounding}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGroundingAdapter() {
		if (groundingItemProvider == null) {
			groundingItemProvider = new GroundingItemProvider(this);
		}

		return groundingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Input} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InputItemProvider inputItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Input}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInputAdapter() {
		if (inputItemProvider == null) {
			inputItemProvider = new InputItemProvider(this);
		}

		return inputItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Output} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OutputItemProvider outputItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Output}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOutputAdapter() {
		if (outputItemProvider == null) {
			outputItemProvider = new OutputItemProvider(this);
		}

		return outputItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Precondition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PreconditionItemProvider preconditionItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Precondition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPreconditionAdapter() {
		if (preconditionItemProvider == null) {
			preconditionItemProvider = new PreconditionItemProvider(this);
		}

		return preconditionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Effect} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EffectItemProvider effectItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Effect}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEffectAdapter() {
		if (effectItemProvider == null) {
			effectItemProvider = new EffectItemProvider(this);
		}

		return effectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.WebService} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WebServiceItemProvider webServiceItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.WebService}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createWebServiceAdapter() {
		if (webServiceItemProvider == null) {
			webServiceItemProvider = new WebServiceItemProvider(this);
		}

		return webServiceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.Service} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ServiceItemProvider serviceItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.Service}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createServiceAdapter() {
		if (serviceItemProvider == null) {
			serviceItemProvider = new ServiceItemProvider(this);
		}

		return serviceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.ODM_OWLClass} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ODM_OWLClassItemProvider odM_OWLClassItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.ODM_OWLClass}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createODM_OWLClassAdapter() {
		if (odM_OWLClassItemProvider == null) {
			odM_OWLClassItemProvider = new ODM_OWLClassItemProvider(this);
		}

		return odM_OWLClassItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.RegistrationRole} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RegistrationRoleItemProvider registrationRoleItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.RegistrationRole}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRegistrationRoleAdapter() {
		if (registrationRoleItemProvider == null) {
			registrationRoleItemProvider = new RegistrationRoleItemProvider(this);
		}

		return registrationRoleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SWSInteraction.SWSInteractionViewpoint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SWSInteractionViewpointItemProvider swsInteractionViewpointItemProvider;

	/**
	 * This creates an adapter for a {@link SWSInteraction.SWSInteractionViewpoint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSWSInteractionViewpointAdapter() {
		if (swsInteractionViewpointItemProvider == null) {
			swsInteractionViewpointItemProvider = new SWSInteractionViewpointItemProvider(this);
		}

		return swsInteractionViewpointItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (planItemProvider != null) planItemProvider.dispose();
		if (semanticWebAgentItemProvider != null) semanticWebAgentItemProvider.dispose();
		if (roleItemProvider != null) roleItemProvider.dispose();
		if (ssMatchmakerAgentItemProvider != null) ssMatchmakerAgentItemProvider.dispose();
		if (sS_RegisterPlanItemProvider != null) sS_RegisterPlanItemProvider.dispose();
		if (sS_FinderPlanItemProvider != null) sS_FinderPlanItemProvider.dispose();
		if (sS_AgreementPlanItemProvider != null) sS_AgreementPlanItemProvider.dispose();
		if (sS_ExecutorPlanItemProvider != null) sS_ExecutorPlanItemProvider.dispose();
		if (swsItemProvider != null) swsItemProvider.dispose();
		if (interfaceItemProvider != null) interfaceItemProvider.dispose();
		if (processItemProvider != null) processItemProvider.dispose();
		if (groundingItemProvider != null) groundingItemProvider.dispose();
		if (inputItemProvider != null) inputItemProvider.dispose();
		if (outputItemProvider != null) outputItemProvider.dispose();
		if (preconditionItemProvider != null) preconditionItemProvider.dispose();
		if (effectItemProvider != null) effectItemProvider.dispose();
		if (webServiceItemProvider != null) webServiceItemProvider.dispose();
		if (serviceItemProvider != null) serviceItemProvider.dispose();
		if (odM_OWLClassItemProvider != null) odM_OWLClassItemProvider.dispose();
		if (registrationRoleItemProvider != null) registrationRoleItemProvider.dispose();
		if (swsInteractionViewpointItemProvider != null) swsInteractionViewpointItemProvider.dispose();
	}

}
