/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SWSInteraction.util;

import SWSInteraction.Effect;
import SWSInteraction.Grounding;
import SWSInteraction.Input;
import SWSInteraction.Interface;
import SWSInteraction.ODM_OWLClass;
import SWSInteraction.Output;
import SWSInteraction.Plan;
import SWSInteraction.Precondition;
import SWSInteraction.RegistrationRole;
import SWSInteraction.Role;
import SWSInteraction.SSMatchmakerAgent;
import SWSInteraction.SS_AgreementPlan;
import SWSInteraction.SS_ExecutorPlan;
import SWSInteraction.SS_FinderPlan;
import SWSInteraction.SS_RegisterPlan;
import SWSInteraction.SWS;
import SWSInteraction.SWSInteractionPackage;
import SWSInteraction.SWSInteractionViewpoint;
import SWSInteraction.SemanticWebAgent;
import SWSInteraction.Service;
import SWSInteraction.WebService;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see SWSInteraction.SWSInteractionPackage
 * @generated
 */
public class SWSInteractionSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static SWSInteractionPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SWSInteractionSwitch() {
		if (modelPackage == null) {
			modelPackage = SWSInteractionPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case SWSInteractionPackage.PLAN: {
				Plan plan = (Plan)theEObject;
				T result = casePlan(plan);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SEMANTIC_WEB_AGENT: {
				SemanticWebAgent semanticWebAgent = (SemanticWebAgent)theEObject;
				T result = caseSemanticWebAgent(semanticWebAgent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.ROLE: {
				Role role = (Role)theEObject;
				T result = caseRole(role);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SS_MATCHMAKER_AGENT: {
				SSMatchmakerAgent ssMatchmakerAgent = (SSMatchmakerAgent)theEObject;
				T result = caseSSMatchmakerAgent(ssMatchmakerAgent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SS_REGISTER_PLAN: {
				SS_RegisterPlan sS_RegisterPlan = (SS_RegisterPlan)theEObject;
				T result = caseSS_RegisterPlan(sS_RegisterPlan);
				if (result == null) result = casePlan(sS_RegisterPlan);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SS_FINDER_PLAN: {
				SS_FinderPlan sS_FinderPlan = (SS_FinderPlan)theEObject;
				T result = caseSS_FinderPlan(sS_FinderPlan);
				if (result == null) result = casePlan(sS_FinderPlan);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SS_AGREEMENT_PLAN: {
				SS_AgreementPlan sS_AgreementPlan = (SS_AgreementPlan)theEObject;
				T result = caseSS_AgreementPlan(sS_AgreementPlan);
				if (result == null) result = casePlan(sS_AgreementPlan);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SS_EXECUTOR_PLAN: {
				SS_ExecutorPlan sS_ExecutorPlan = (SS_ExecutorPlan)theEObject;
				T result = caseSS_ExecutorPlan(sS_ExecutorPlan);
				if (result == null) result = casePlan(sS_ExecutorPlan);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SWS: {
				SWS sws = (SWS)theEObject;
				T result = caseSWS(sws);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.INTERFACE: {
				Interface interface_ = (Interface)theEObject;
				T result = caseInterface(interface_);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.PROCESS: {
				SWSInteraction.Process process = (SWSInteraction.Process)theEObject;
				T result = caseProcess(process);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.GROUNDING: {
				Grounding grounding = (Grounding)theEObject;
				T result = caseGrounding(grounding);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.INPUT: {
				Input input = (Input)theEObject;
				T result = caseInput(input);
				if (result == null) result = caseODM_OWLClass(input);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.OUTPUT: {
				Output output = (Output)theEObject;
				T result = caseOutput(output);
				if (result == null) result = caseODM_OWLClass(output);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.PRECONDITION: {
				Precondition precondition = (Precondition)theEObject;
				T result = casePrecondition(precondition);
				if (result == null) result = caseODM_OWLClass(precondition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.EFFECT: {
				Effect effect = (Effect)theEObject;
				T result = caseEffect(effect);
				if (result == null) result = caseODM_OWLClass(effect);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.WEB_SERVICE: {
				WebService webService = (WebService)theEObject;
				T result = caseWebService(webService);
				if (result == null) result = caseService(webService);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SERVICE: {
				Service service = (Service)theEObject;
				T result = caseService(service);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.ODM_OWL_CLASS: {
				ODM_OWLClass odM_OWLClass = (ODM_OWLClass)theEObject;
				T result = caseODM_OWLClass(odM_OWLClass);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.REGISTRATION_ROLE: {
				RegistrationRole registrationRole = (RegistrationRole)theEObject;
				T result = caseRegistrationRole(registrationRole);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SWSInteractionPackage.SWS_INTERACTION_VIEWPOINT: {
				SWSInteractionViewpoint swsInteractionViewpoint = (SWSInteractionViewpoint)theEObject;
				T result = caseSWSInteractionViewpoint(swsInteractionViewpoint);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Plan</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Plan</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePlan(Plan object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Semantic Web Agent</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Semantic Web Agent</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSemanticWebAgent(SemanticWebAgent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Role</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Role</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRole(Role object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SS Matchmaker Agent</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SS Matchmaker Agent</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSSMatchmakerAgent(SSMatchmakerAgent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SS Register Plan</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SS Register Plan</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSS_RegisterPlan(SS_RegisterPlan object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SS Finder Plan</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SS Finder Plan</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSS_FinderPlan(SS_FinderPlan object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SS Agreement Plan</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SS Agreement Plan</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSS_AgreementPlan(SS_AgreementPlan object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SS Executor Plan</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SS Executor Plan</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSS_ExecutorPlan(SS_ExecutorPlan object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SWS</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SWS</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSWS(SWS object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Interface</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Interface</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInterface(Interface object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Process</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Process</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseProcess(SWSInteraction.Process object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Grounding</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Grounding</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGrounding(Grounding object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Input</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Input</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInput(Input object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Output</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Output</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOutput(Output object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Precondition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Precondition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrecondition(Precondition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Effect</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Effect</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEffect(Effect object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Web Service</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Web Service</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseWebService(WebService object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Service</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Service</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseService(Service object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ODM OWL Class</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ODM OWL Class</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseODM_OWLClass(ODM_OWLClass object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Registration Role</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Registration Role</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRegistrationRole(RegistrationRole object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Viewpoint</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Viewpoint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSWSInteractionViewpoint(SWSInteractionViewpoint object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //SWSInteractionSwitch
